#if defined _xp_string_included
	#endinput
#endif
#define _xp_string_included
#include <amxmodx>
#include <fakemeta>
#pragma tabsize 0

#define XPL_TIMEFORMAT "%d.%m.%Y %H:%M:%S"
stock xp_generatecode(const vgid[], outputex[14])
{
	new outstrex[5];
	new outputc[14];
	for(new i = 0; i < 4; i++)
	{
		new crandom = 48 + random(10);
		new crandom2 = 97 + random(26);
		if(random(2) == 0)
		{
			outstrex[i] = crandom;
		}
		else
		{
			outstrex[i] = crandom2;
		}
	}
	formatex(outputc, 13, "%s%s", vgid, outstrex);
	copy(outputex, 13, outputc);
}
stock get_currenttime(writedata[], lenght)
{
	new CurrentTime[15];
	get_time("%H:%M:%S",CurrentTime, 14); 
	new year, month, day;
	date(year, month, day);
	if(month < 10 && day < 10)
	{
		formatex(writedata,lenght,"0%i.0%i.%i %s", day, month, year, CurrentTime);
	}
	else if(day < 10)
	{
		formatex(writedata,lenght,"0%i.%i.%i %s", day, month, year, CurrentTime);
	}
	else if(month < 10)
	{
		formatex(writedata,lenght,"%i.0%i.%i %s", day, month, year, CurrentTime);
	}
	else
	{
		formatex(writedata,lenght,"%i.%i.%i %s", day, month, year, CurrentTime);
	}
}
stock get_currenttime_num()
{
	new CurrentTimeC[30];
	get_currenttime(CurrentTimeC, 29);
	return parse_time(CurrentTimeC, XPL_TIMEFORMAT);
}
stock convert_to_unsafestring(safestr_in[], nlength)
{
	replace_all(safestr_in, nlength, "{:xpl_sol:}", "<")
	replace_all(safestr_in, nlength, "{:xpl_sag:}", ">") 
	replace_all(safestr_in, nlength, "{:xpl_ttirnak:}", "'") 
	replace_all(safestr_in, nlength, "{:xpl_ctirnak:}", "^"") 
	replace_all(safestr_in, nlength, "{:xpl_esittir:}", "=") 
	replace_all(safestr_in, nlength, "{:xpl_slash:}", "/" ) 
	replace_all(safestr_in, nlength, "{:xpl_tslash:}", "\" ) 
	replace_all(safestr_in, nlength, "{:xpl_dtirnak:}", "`" ) 
	replace_all(safestr_in, nlength, "{:xpl_ddtirnak:}", "´") 
}
stock convert_to_safestring(safestr_in[], nlength)
{
	replace_all(safestr_in, nlength, "<", "{:xpl_sol:}")
	replace_all(safestr_in, nlength, ">", "{:xpl_sag:}") 
	replace_all(safestr_in, nlength, "'", "{:xpl_ttirnak:}") 
	replace_all(safestr_in, nlength, "^"", "{:xpl_ctirnak:}") 
	replace_all(safestr_in, nlength, "=", "{:xpl_esittir:}") 
	replace_all(safestr_in, nlength, "/", "{:xpl_slash:}") 
	replace_all(safestr_in, nlength, "\", "{:xpl_tslash:}") 
	replace_all(safestr_in, nlength, "`", "{:xpl_dtirnak:}") 
	replace_all(safestr_in, nlength, "´", "{:xpl_ddtirnak:}") 
}
//Son Güncelleme: build 3, 4.10.2014
stock ExplodeString( p_szOutput[][], p_nMax, p_nSize, p_szInput[], p_szDelimiter ) 
{     
	new nIdx = 0, l = strlen(p_szInput)     
	new nLen = (1 + copyc( p_szOutput[nIdx], p_nSize, p_szInput, p_szDelimiter ))     
	while( (nLen < l) && (++nIdx < p_nMax) )
		nLen += (1 + copyc( p_szOutput[nIdx], p_nSize, p_szInput[nLen], p_szDelimiter ))
	return nIdx 
}
stock TrimLeft(Output[], Text[], Char, const trcount = 0)
{
	new ilen = strlen(Text);
	if(ilen <= 0) return ilen;
	new tcount = 0;
	for(new i = 0;i < ilen; i++)
	{
		if(Text[i] != Char) break;
		tcount++;
		if(trcount > 0 && tcount >= trcount) break;
	}
	if(tcount <= 0) return ilen;
	copy(Output, ilen, Text[tcount]);
	return  ilen - tcount;
}
stock TrimRight(Output[], Text[], Char, const trcount = 0)
{
	new ilen = strlen(Text);
	if(ilen <= 0) return ilen;
	new tcount = 0;
	for(new i = ilen - 1;i >= 0; i--)
	{
		if(Text[i] != Char) break;
		tcount++;
		if(trcount > 0 && tcount >= trcount) break;
	}
	if(tcount <= 0) return ilen;
	copy(Output, ilen - tcount, Text);
	return  ilen - tcount;
}
stock TrimBoth(Output[], Text[], Char, const trcount = 0)
{
	new ilen;
	TrimLeft(Output, Text, Char, trcount);
	ilen = TrimRight(Output, Output, Char, trcount);
	return ilen;
}
stock CharIndex(const Input[], const mChar)
{
	for(new i = 0;i < strlen(Input); i++)
	{
		if(Input[i] == mChar)
		{
			return i;
		}
	}
	return -1;
}
stock bool:bCharIndex(const Input[], const mChar)
{
	if(CharIndex(Input, mChar) >= 0) return true;
	return false;
}
stock EmptyAll(Input[][], Max, Len)
{
	if(Max <= 0) return;
	if(Len <= 0) return;
	for(new i = 0; i <Max; i++)
	{
		formatex(Input[i], Len, "")
	}
}
stock TrieGetStringEx(Trie:handle, const key[], output[], outputsize, &size = 0)
{
	if(TrieKeyExists(handle, key))
	{
		TrieGetString(handle, key, output, outputsize, size);
		return 0;
	}
	else
	{
		formatex(output, outputsize, "");
	}
	return 1;
}
stock Trie:ToNameValueString(input[], &totalc, bool:trimsjonvar = false)
{
	new Trie:nNVTrie = TrieCreate();
	if(trimsjonvar)
	{
		TrimLeft(input, input, '{');
		TrimRight(input, input, '}');
	}
	new SplitStrEx[50][512];
	new SplitStrExTreme[50][512];
	new splitted = ExplodeStringEx(SplitStrEx, 50, 511, input, ",", true);
	new totalcex = 0;
	for(new i = 0; i < splitted; i++)
	{
		ExplodeStringEx(SplitStrExTreme, 50, 511, SplitStrEx[i], ":");
		TrieSetString(nNVTrie, SplitStrExTreme[0], SplitStrExTreme[1]);
		totalcex++;
	}
	totalc = totalcex;
	return nNVTrie;
	
}
stock ExplodeStringEx(Output[][], const Max, const Len, const Text[], const Delimiter[], bool:addspec = false, bool:crossempty = false)
{
	new bool:isquote = false;
	new Fnd = 0;
	new ccount = 0;
	new ilen = strlen(Text);
	new curchar;
	new CMAX = Max - 1;
	for(new i = 0; i < ilen; i++)
	{
		curchar = Text[i];
		if(curchar == '^"')
		{
			if(isquote)
			{
				isquote = false;
			}
			else
			{
				isquote = true;
			}
		}
		if(bCharIndex(Delimiter, curchar) && !isquote)
		{
			if(crossempty && ccount == 0)
			{
				continue;
			}
			if(Fnd + 1 > CMAX)
			{
				if(ccount > Len)
				{
					break;
				}
				copy(Output[Fnd][ccount], 1, Text[i]);
				ccount++;
				continue;
			}
			else
			{
				Fnd++;
			}
			ccount = 0;
			continue;
		}
		if(curchar != '^"') 
		{
			copy(Output[Fnd][ccount], 1, Text[i]);
			ccount++;
		}
		else
		{
			if(addspec)
			{
				copy(Output[Fnd][ccount], 1, Text[i]);
				ccount++;
			}
		}
		if(ccount > Len)
		{
			Fnd++;
			if(Fnd > CMAX) break;
			ccount = 0;
		}
		if(i == ilen - 1 && ccount > 0)
		{			
			Fnd++;
			ccount = 0;
			continue;
		}
	}
	return Fnd;
}
public getMenuIndex_str(menu, item, Output[], len)
{
	if(len <= 0) return;
	new MenuInfo[255], MenuItemName[60], access, callback;
	menu_item_getinfo(menu, item, access, MenuInfo, 254, MenuItemName, 59, callback)
	copy(Output, len, MenuInfo);
}
stock bool:str_started(source[], find[], bool:exact = false)
{
	new slen = strlen(find);
	new sourcelen = strlen(source);
	if(equali(source, find, slen))
	{
		if(exact)
		{
			if(slen == sourcelen) return true;
			if(source[slen] == ' ') return true;
			return false;
		}
		return true;
	}
	return false;
}
stock bool:str_ended(source[], find[])
{
	new len = strlen(source) - strlen(find);
	if(len <= 0) return false;
	if (equali(source[len], find))
	{
		return true;
	}
	return false;
}
stock float_to_str_ex(Float:Value, count, output[], len)
{
	new TxtEx[200];
	new TxtOupPut[2][200];
	new First[100];
	new Second[100];
	format(TxtEx, 999, "%f", Value);
	ExplodeString(TxtOupPut, 2, 999, TxtEx, '.');
	format(First, 99, "%s", TxtOupPut[0]);
	format(Second, count, "%s", TxtOupPut[1]);	
	format(TxtEx, 199, "%s.%s", First, Second);
	copy(output, len, TxtEx);
}
stock num_to_time(output[], olen, seconds)
{
	new sec = seconds % 60;
	new Min = (seconds - sec) / 60;
	new Hour = (Min - Min % 60) / 60;
	Min = Min % 60;
	new Day = (Hour - Hour % 24) / 24;
	Hour = Hour % 24;
	new sectext[5];
	new mintext[5];
	new hourtext[5];
	new guntext[6];
	formatex(sectext, 4, "%i", sec);
	formatex(mintext, 4, "%i", Min);
	formatex(hourtext, 4, "%i", Hour);
	formatex(guntext, 5, "%i", Day);
	if(sec < 10)
	{
		formatex(sectext, 4, "0%i", sec);
	}
	if(Min < 10)
	{
		formatex(mintext, 4, "0%i", Min);
	}
	if(Hour < 10)
	{
		formatex(hourtext, 4, "0%i", Hour);
	}
	formatex(output, olen, "%sg %s:%s:%s", guntext, hourtext, mintext, sectext);
}
stock bool:isNumeric(text[])
{
	new ilen = strlen(text);
	TrimBoth(text, text, ' ');
	if(ilen == 0) return false;
	new dcount;
	for(new i = 0; i <= ilen; i++)
	{
		if(text[i] == '.')
		{
			dcount++;
			if(dcount > 1) return false;
		}
		if(!isdigit(text[i]) && text[i] != 0 && text[i] != '.')
		{
			return false;
		}
	}
	return true;
}
stock findinArray(&Array:ConfigRow, Value[])
{
	new mText[2048];
	for(new i = 0; i < ArraySize(ConfigRow); i++)
	{
		ArrayGetString(ConfigRow, i, mText, 2048);
		if(equali(mText, Value))
		{
			return i;
		}
	}
	return -1;
}
stock getArrayValue(&Array:ConfigRow, index, Output[])
{
	new mText[2048];
	if(index < 0)
	{
		return;
	}
	else
	{
		ArrayGetString(ConfigRow, index, mText, 2048);
		copy(Output, 512, mText);
	}
}
stock merge_cmd_commands(outi[], outl, starti = 1, maxi = -1, sjoin[] = " ")
{
	new sc = read_argc();
	if(sc <= 0)
	{
		return 0;
	}
	if(starti < 0) starti = 0;
	if(starti >= sc) starti = sc - 1;
	if(maxi + starti >= sc) maxi = sc - starti;
	if(maxi == -1) maxi = sc - starti;
	new mcmd[1024];
	new twt = 0;
	new stlen = charsmax(mcmd);
	new totalm = 0;
	for(new i = starti; i < starti + maxi; i++)
	{
		new cmdArg[255];
		read_argv(i, cmdArg, 254);
		if(totalm == 0)
		{
			twt += formatex(mcmd[twt], stlen - twt, "%s", cmdArg);
		}
		else
		{
			twt += formatex(mcmd[twt], stlen - twt, "%s%s", sjoin, cmdArg);
		}
		totalm++;
	}
	formatex(outi, outl, mcmd);
	return totalm;
}