#include <amxmodx>
#include <amxmisc>
#include <xp_string>
#include <regex>
//#define USE_ANTIKUFUR
#if defined USE_ANTIKUFUR
#pragma reqlib "lt antikufur"
#if !defined AMXMODX_NOAUTOLOAD
  #pragma loadlib "lt antikufur"
#endif
#endif
#define VERSION "1.2.4" //
#define DEF_MAX_LEN 255
#pragma dynamic 131072
#define prefix "[LTAG] "
enum _: defs_othervars
{
	dov_name[255],
	dov_value[255]
}
enum _: defs_variable
{
	dfv_name[1024],
	dfv_value[1024]
}
enum _: defs_default
{
	bool:df_IsCustom,
	bool:df_IsGroup,
	bool:df_IsEmpty,
	df_info[255],
	df_msg_dead[255],
	df_msg_alive[255],
	df_grp_order,
	df_grp_name[50],
	df_grp_tag[50],
	df_grp_desc[100],
	df_grp_access[50],
	Array:df_headers,
	Array:df_others,
	df_headerscount
}
enum _: defs_user
{
	du_usergroup_name[30],
	du_usergroup_value[30],
	du_usergroup_valueall[60],
	de_userprimary_alive[1024],
	de_userprimary_dead[1024],
	de_usersecondary_alive[1024],
	de_usersecondary_dead[1024],
	de_useroldflags,
	de_grp_order,
	de_grp_name[50],
	de_grp_desc[100],
	de_usr_acc[50],
	de_grp_acc[50],
	de_grp_tag[50],
	de_cst_tag[50],
	de_grp_acc_flags,
	bool:de_grp_spec,
	Array:de_grp_others,
	bool:de_ini_show,
	bool:de_ini_add,
	bool:de_ini_rmv,
	bool:de_ini_change,
	bool:de_ini_addnopref,
	bool:de_ini_notorderobey,
	bool:de_useprimary,
	bool:de_userloaded,
	bool:de_spectag
}
enum _: admin_groups
{
	ag_grp_order,
	ag_grp_name[50],
	ag_grp_desc[100],
	ag_users[33],
	ag_totalusers
}
enum _: usersini_vals
{
	uiv_username[100],
	uiv_password[100],
	uiv_access[100],
	uiv_kicktype[100],
	uiv_usergroup[100],
	uiv_othervars[500],
	uiv_written[100],
	uiv_grp_order,
	uiv_grp_access[100],
	bool:uiv_issummary,
	bool:uiv_isblank,
	bool:uiv_removed
}
enum _: useractiveitem
{
	bool:uai_inmenu,
	bool:uai_isnew,
	uai_udataindex,
	uai_lastpage,
	uai_lastloaded,
	uai_activeaction[30],
	uai_lasttype,
	uai_lastargs[50]
}
new ua_lastmessage[33][192]
new uai_udata[33][usersini_vals];
new msg_Admin[defs_default];
new msg_NonAdmin[defs_default];
new Array:msg_Groups;
new Array:msg_Customs;
new Array:TempDefs;
new userformats_c[33][defs_user];
new pcvar_speccar;
new pcvar_enabled;
new pcvar_allchat;
new pcvar_accessoverride;
new pcvar_accessoverridekey;
new Array:CurrentUsersIni;
new nTotalUserCount = 0;
new nTotalSummaryCount = 0;
new nTotalBlankCount = 0;
new nUserActiveItems[33][useractiveitem]
new pcvar_defaccess, pcvar_defgroup, pcvar_clanprefix, pcvar_defkicktype, pcvar_enableinieditor;
new pcvar_autobackusersini, pcvar_autobackminuser, pcvar_kicktypeauto, pcvar_kicktypehide;
new pcvar_autosaveaftermodify;
new bool:lastmenuissavetofile[33];
new Float:NextSaveTime;
new totalloaded = 0;
#if defined USE_ANTIKUFUR
native xp_blocktextpoints(usertext[]);
#endif

public plugin_init()
{
	register_plugin("Lt - AdminGroup And Say", VERSION, "Lt.Ibrahim(Ibm)")
	pcvar_enableinieditor = register_cvar("lt_admineditor", "1");
	pcvar_enabled = register_cvar("lt_chatenabled", "1"); //1 ise Say sistemi açık  demektir.
	pcvar_speccar = register_cvar("lt_disallowprefixchar", "0"); // / 1 yaızılırsa / ve ! ile başlayan karakterlerde devreye girmez
	pcvar_allchat = register_cvar("lt_allchat", "1"); // / 1 olursa ölülerinkini diriler dirilerinkini ise ölüler görür
	pcvar_accessoverride = register_cvar("lt_accessoverride", "1"); //1 olursa kullanıcı yetkilerini ini dosyasındna çeker
	pcvar_accessoverridekey = register_cvar("lt_accessoverride_key", "z");
	pcvar_clanprefix = register_cvar("lt_clanprefix", "LTAG | ");
	pcvar_defaccess = register_cvar("lt_defaultaccess", "z");
	pcvar_defgroup = register_cvar("lt_defaultgroup", "c");
	pcvar_defkicktype = register_cvar("lt_defaultkicktype", "a");
	pcvar_autobackusersini = register_cvar("lt_usersinibackup_time", "900"); //save as users_lt_backup.ini
	pcvar_autobackminuser = register_cvar("lt_usersinibackup_minuser", "2"); //save as users_lt_backup.ini
	pcvar_kicktypeauto = register_cvar("lt_kicktype_auto", "1"); //Auto assign after enter username (steamid ce username a)
	pcvar_kicktypehide = register_cvar("lt_kicktype_hide", "1"); //Hide kicktype
	pcvar_autosaveaftermodify = register_cvar("lt_autosaveaftermodify", "1");
	register_message(get_user_msgid("SayText"), "hook_saytext");
	register_concmd("lt_reloadall", "lt_reloadall_n", ADMIN_CVAR, "Reload all customization(Tum kisisellestirmeleri tekrar yukler)");
	register_concmd("lt_reloadusersini", "lt_reloadusersini_m", ADMIN_CVAR, "Reload users.ini files(users.Ini dosyasini tekrar yukler)");	
	register_concmd("lt_reloadini", "lt_reloadini_m", ADMIN_CVAR, "Reload ini files(Ini dosyasini tekrar yukler)");
	register_concmd("lt_reloadusers", "lt_reloadusers_m", ADMIN_CVAR, "Reload user group(User gruplarini tekrar yukler)");
	register_concmd("lt_settag", "lt_settag_m", ADMIN_ADMIN, "Sets myself tag(Kendi tagini ayarla)");
	register_clcmd("say", "say_normal", -1, "")
	register_clcmd("say_team", "say_teamex", -1, "")
	register_clcmd("say /admins", "say_adminler", -1, "")
	register_clcmd("say /admin", "say_adminler", -1, "")
	register_clcmd("say /adminler", "say_adminler", -1, "")
	register_clcmd("say /giveadmin", "say_adminayarla", -1, "");
	register_clcmd("say /admineditor", "say_adminayarla", -1, "");
	register_clcmd("say /setadmin", "say_adminayarla", -1, "");
	register_clcmd("say /yetkiver", "say_adminayarla", -1, "");
	register_clcmd("lt_cUser","lt_KullaniciAdiAndOth",-1,"")
	register_clcmd("lt_cPass","lt_KullaniciAdiAndOth",-1,"")
	register_clcmd("lt_cAccess","lt_KullaniciAdiAndOth",-1,"")
	register_clcmd("lt_cKickType","lt_KullaniciAdiAndOth",-1,"")
	register_clcmd("lt_cGroup","lt_KullaniciAdiAndOth",-1,"")
	register_clcmd("lt_cFindAdmin","lt_KullaniciAdiAndOth",-1,"")
	register_clcmd("lt_cEnterTag","lt_KullaniciAdiAndOth",-1,"")
	register_clcmd("lt_admin_about", "lt_showabout", -1, "");
	set_task(2.00, "lt_checkaccess", 0, "", 0, "b");
	register_dictionary("lt_admingroup.txt");
	new Float:ESure = get_pcvar_float(pcvar_autobackusersini);
	NextSaveTime = get_gametime() + ESure;
}
public lt_settag_m(id, level, cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED;
	}
	new ArgV[50];
	merge_cmd_commands(ArgV, 49);
	if(!userformats_c[id][de_spectag])
	{
		console_print(id, "%s%L", prefix, id, "LT_ADM_SETTAG_ERR");
	}
	else
	{
		console_print(id, "%s%L", prefix, id, "LT_ADM_SETTAG_SC");
		formatex(userformats_c[id][de_cst_tag], 49, ArgV);
		save_user_tagtofile(id, ArgV);
	}
	return PLUGIN_HANDLED;
}
stock save_user_tagtofile(id, UserTag[])
{
	new uname[50];
	get_user_name(id, uname, 49);
	new usteamid[50];
	get_user_authid(id, usteamid, 49);
	
	new configdir[80];
	get_configsdir(configdir, 79);
	formatex(configdir, 79, "%s/lt_usertags.ini", configdir);
	
	new tempdir[80];
	get_configsdir(tempdir, 79);
	formatex(tempdir, 79, "%s/lt_usertags_temp.ini", tempdir);
	new SplitStr[6][1024];
	new text[1024]
	new textreal[1024];
	new fp = fopen(configdir, "r");
	new fwrite = fopen(tempdir, "w");
	if(!fwrite)
	{
		return;
	}
	new iwrited = 0;
	if (fp)
	{
		while (!feof(fp))
		{
			fgets(fp, text, charsmax(text));
			formatex(textreal, 1023, text);
			if (text[0] == ';' || iwrited)
			{
				fprintf(fwrite, textreal);
				continue;
			}
			TrimBoth(text, text, '^n');
			TrimBoth(text, text, '^r');
			new stlen = strlen(text);
			if(stlen <= 0) 
			{
				fprintf(fwrite, textreal);
				continue;
			}
			for(new j = 0; j < 6; j++)
			{
				formatex(SplitStr[j], 1023, "");
			}
			new spltlen = ExplodeStringEx(SplitStr, 2, 1023, text, " ", true, true);
			if(spltlen <= 1)
			{
				fprintf(fwrite, textreal);
			}
			TrimBoth(SplitStr[0], SplitStr[0], ' ');
			new SplitALLRng[4][100];
			new spltlenex = ExplodeStringEx(SplitALLRng, 3, 99, SplitStr[0], ";");
			new founded = 0;
			for(new i = 0; i < spltlenex; i++)
			{
				if(equali(uname, SplitALLRng[i]) || equali(usteamid, SplitALLRng[i]))
				{
					founded = 1;
					break;
				}
			}
			if(!founded)
			{
				fprintf(fwrite, textreal);
			}
			else
			{
				iwrited = 1;
				if(strlen(UserTag) <= 0 || equali(UserTag, "!!"))
				{
					continue;
				}
				else
				{
					fprintf(fwrite, "^"%s^";^"%s^" ^"%s^"^n", uname, usteamid, UserTag);
				}
			}
		}
	}
	if(!iwrited && strlen(UserTag) > 0 && !equali(UserTag, "!!"))
	{
		fprintf(fwrite, "^"%s^";^"%s^" ^"%s^"^n", uname, usteamid, UserTag);
	}
	if(fp)
	{
		fclose(fp)
		delete_file(configdir);
	}
	fclose(fwrite);
	rename_file(tempdir, configdir, 1);
}
stock get_user_tagfromfile(id, OutTag[], OutLen)
{
	new uname[50];
	get_user_name(id, uname, 49);
	new usteamid[50];
	get_user_authid(id, usteamid, 49);
	
	new configdir[80];
	get_configsdir(configdir, 79);
	formatex(configdir, 79, "%s/lt_usertags.ini", configdir);
	new SplitStr[6][1024];
	new text[1024]
	new fp = fopen(configdir, "r");
	if (!fp)
	{
		return;
	}
	while (!feof(fp))
	{
		fgets(fp, text, charsmax(text));
		if (text[0] == ';')
		{
			continue;
		}
		TrimBoth(text, text, '^n');
		TrimBoth(text, text, '^r');
		new stlen = strlen(text);
		if(stlen <= 0) 
		{
			continue;
		}
		for(new j = 0; j < 6; j++)
		{
			formatex(SplitStr[j], 1023, "");
		}
		new spltlen = ExplodeStringEx(SplitStr, 2, 1023, text, " ", true, true);
		if(spltlen <= 1) continue;
		TrimBoth(SplitStr[0], SplitStr[0], ' ');
		new SplitALLRng[4][100];
		new spltlenex = ExplodeStringEx(SplitALLRng, 3, 99, SplitStr[0], ";");
		new founded = 0;
		for(new i = 0; i < spltlenex; i++)
		{
			if(equali(uname, SplitALLRng[i]) || equali(usteamid, SplitALLRng[i]))
			{
				founded = 1;
				break;
			}
		}
		if(!founded) continue;
		remove_quotes(SplitStr[1]);
		formatex(OutTag, OutLen, SplitStr[1]);
		break;
	}
	fclose(fp);
}
public li_listaction(id, n_type)
{
	new strk[512];
	new LangStr[255];
	new mlstr = charsmax(LangStr);
	new mlstrk = charsmax(strk);
	nUserActiveItems[id][uai_lasttype] = n_type;
	switch(n_type)
	{
		case 1:
		{
			formatex(strk, mlstrk, "%L", id, "LT_UNAME_SEL");
		}
		case 2:
		{
			formatex(strk, mlstrk, "%L", id, "LT_GNAME_SEL");
		}
		case 3: 
		{
			formatex(strk, mlstrk, "%L", id, "LT_LIST_SEL");
		}
	}
	new menu = menu_create(strk, "LtListActionHandler")
	if(n_type == 1) //Username select
	{
		formatex(LangStr, mlstr, "%L", id, "LT_UNAME_SEL1");
		menu_additem( menu, LangStr, "sl_uname_manual", 0, menu_makecallback("lt_adminmainmenu_cb") );
		
		if(userformats_c[id][de_ini_addnopref])
		{
			formatex(LangStr, mlstr, "%L", id, "LT_UNAME_SEL2");
			menu_additem( menu, LangStr, "sl_uname_users_nopref", 0, menu_makecallback("lt_adminmainmenu_cb") );
		}
		formatex(LangStr, mlstr, "%L", id, "LT_UNAME_SEL4");
		menu_additem( menu, LangStr, "sl_uname_users_steam", 0, menu_makecallback("lt_adminmainmenu_cb") );
		
		formatex(LangStr, mlstr, "%L", id, "LT_UNAME_SEL3");
		menu_additem( menu, LangStr, "sl_uname_users_pref", 0, menu_makecallback("lt_adminmainmenu_cb") );
	}
	else if(n_type == 2) //Usergroup select
	{
		formatex(LangStr, mlstr, "%L", id, "LT_GNAME_SEL1");
		menu_additem( menu, LangStr, "sl_grup_manual", 0, menu_makecallback("lt_adminmainmenu_cb") );
		
		formatex(LangStr, mlstr, "%L", id, "LT_GNAME_SEL2");
		menu_additem( menu, LangStr, "sl_grup_list", 0, menu_makecallback("lt_adminmainmenu_cb") );
	}
	else if(n_type == 3) //List select
	{
		formatex(LangStr, mlstr, "%L", id, "LT_LIST_SEL1");
		menu_additem( menu, LangStr, "sl_admin_all", 0, menu_makecallback("lt_adminmainmenu_cb") );
		
		formatex(LangStr, mlstr, "%L", id, "LT_LIST_SEL2");
		menu_additem( menu, LangStr, "sl_admin_game", 0, menu_makecallback("lt_adminmainmenu_cb") );
		
		formatex(LangStr, mlstr, "%L", id, "LT_LIST_SEL3");
		menu_additem( menu, LangStr, "sl_admin_find", 0, menu_makecallback("lt_adminmainmenu_cb") );
	}
	menu_display(id, menu, 0);
}
public LtListActionHandler(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy( menu );
		if(nUserActiveItems[id][uai_lasttype] == 3)
		{
			set_task(0.1, "lt_showadminmenu", id)
		}
		else
		{
			set_task(0.1, "lt_showadmininfomenu", id)
		}
		//set_task(0.1, "lt_showadmininfomenu", id)
		return;
	}
	if(nUserActiveItems[id][uai_lastloaded] != totalloaded)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_ANY");
		menu_destroy( menu );
		return;
	}
	new itemarg[50], MenuItemName[32];
	new access, callback;
	menu_item_getinfo( menu, item, access, itemarg, charsmax(itemarg), MenuItemName, 31, callback)
	if(equal(nUserActiveItems[id][uai_activeaction], "username_select"))
	{
		if(get_pcvar_num(pcvar_kicktypeauto))
		{
			if(str_started(itemarg, "STEAM_"))
			{
				formatex(uai_udata[id][uiv_kicktype], 99, "ce");
			}
			else
			{
				formatex(uai_udata[id][uiv_kicktype], 99, "a");
			}
		}
		formatex(uai_udata[id][uiv_username], 99, itemarg);
		menu_destroy( menu );
		set_task(0.1, "lt_showadmininfomenu", id)
		formatex(nUserActiveItems[id][uai_activeaction], 29, "");
		return;
	}
	if(equal(nUserActiveItems[id][uai_activeaction], "usergroup_select"))
	{
		formatex(uai_udata[id][uiv_usergroup], 99, itemarg);
		if(str_ended(itemarg, "{g_desc}"))
		{
			nUserActiveItems[id][uai_inmenu] = true;
			formatex(nUserActiveItems[id][uai_activeaction], 29, "modify_entertag");
			client_cmd(id, "messagemode lt_cEnterTag");
		}
		else
		{
			formatex(nUserActiveItems[id][uai_activeaction], 29, "");
			set_task(0.1, "lt_showadmininfomenu", id)
		}
		menu_destroy( menu );
		return;
	}	
	if(equal(itemarg, "sl_uname_manual")) //
	{
		nUserActiveItems[id][uai_inmenu] = true;
		formatex(nUserActiveItems[id][uai_activeaction], 29, "modify_username");
		client_cmd(id, "messagemode lt_cUser");
	}
	if(equal(itemarg, "sl_grup_manual")) //
	{
		nUserActiveItems[id][uai_inmenu] = true;
		formatex(nUserActiveItems[id][uai_activeaction], 29, "modify_group");
		client_cmd(id, "messagemode lt_cGroup");
	}
	if(equal(itemarg, "sl_admin_all")) //
	{
		lt_showadminlistmenu(id, 0, "");
	}
	if(equal(itemarg, "sl_admin_game"))
	{
		lt_showadminlistmenu(id, 0, "!##ingame##!");
	}
	if(equal(itemarg, "sl_admin_find")) //
	{
		nUserActiveItems[id][uai_inmenu] = true;
		formatex(nUserActiveItems[id][uai_activeaction], 29, "sl_admin_find");
		client_cmd(id, "messagemode lt_cFindAdmin");
	}
	if(equal(itemarg, "sl_uname_users_nopref"))
	{
		set_task(0.1, "lt_listusers_nopref", id)
	}
	if(equal(itemarg, "sl_uname_users_pref"))
	{
		set_task(0.1, "lt_listusers_pref", id)
	}
	if(equal(itemarg, "sl_grup_list"))
	{
		set_task(0.1, "lt_listgroups", id)
	}
	if(equal(itemarg, "sl_uname_users_steam"))
	{
		set_task(0.1, "lt_listusers_steam", id)
	}
	menu_destroy( menu );
}
public lt_listusers_steam(id)
{
	lt_listusers(id, 2);
}
public lt_listusers_pref(id)
{
	lt_listusers(id, 1);
}
public lt_listusers_nopref(id)
{
	lt_listusers(id, 0);
}
public lt_listusers(id, prefixes)
{
	new upref[30];
	get_pcvar_string(pcvar_clanprefix, upref, 29);
	new totalusers = 0;
	new strk[512];
	new mlstrk = charsmax(strk);
	formatex(strk, mlstrk, "%L", id, "LT_LIST_USERT");
	new menu = menu_create(strk, "LtListActionHandler")
	for(new tid = 1; tid < 33; tid++)
	{
		if(!is_user_connected(tid)) continue;
		if(is_user_bot(tid)) continue;
		if(userformats_c[tid][de_userloaded]) continue;
		if(userformats_c[tid][de_grp_acc_flags] != 0) continue;
		new uname[50];
		new unamenew[50];
		new usteamid[50];
		new uinfo[50];
		get_user_name(tid, uname, 49);
		if(prefixes == 2)
		{
			get_user_authid(tid, usteamid, 49);
			formatex(uinfo, 49, usteamid);
			formatex(unamenew, 49, "%s \d%s", usteamid, uname);
		}
		else
		{

			if(!str_started(uname, upref) && prefixes == 1)
			{
				formatex(unamenew, 49, "%s%s", upref, uname);
			}
			else
			{
				formatex(unamenew, 49, uname);
			}
			formatex(uinfo, 49, unamenew);
		}
		menu_additem( menu, unamenew, uinfo, 0, menu_makecallback("lt_adminmainmenu_cb") );
		totalusers++;
	}
	if(totalusers <= 0)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_LIST_USRERR");
		menu_destroy(menu);
		set_task(0.1, "list_username", id)
		return;
	}		
	formatex(nUserActiveItems[id][uai_activeaction],  29, "username_select");
	menu_display(id, menu, 0);
}
public lt_listgroups(id)
{
	new totalgroup = 0;
	new strk[512];
	new mlstrk = charsmax(strk);
	formatex(strk, mlstrk, "%L", id, "LT_LIST_USERG");
	new menu = menu_create(strk, "LtListActionHandler")
	new grpsize = ArraySize(msg_Groups);
	new bool:notobey = userformats_c[id][de_ini_notorderobey];
	new userorder = userformats_c[id][de_grp_order];
	new Array:TempList = ArrayCreate(100);
	for(new i = 0; i < grpsize; i++)
	{
		new CurrentArray[defs_default];
		ArrayGetArray(msg_Groups, i, CurrentArray);
		if(!notobey)
		{
			if(userorder <  CurrentArray[df_grp_order])
			{
				continue;
			}
		}
		new grphc = CurrentArray[df_headerscount];
		for (new j = 0; j < grphc; j++)
		{
			new uvars[100];
			new uvarsex[100];
			ArrayGetString(CurrentArray[df_headers], j, uvars, 99);
			new mitemn[100];
			formatex(mitemn, 99, "%s \w(\d %s\w)", uvars, CurrentArray[df_grp_tag]);
			if(containi(CurrentArray[df_grp_tag], "{g_desc}") >= 0)
			{
				formatex(uvarsex, 99, "%s-%s", uvars, "{g_desc}");
			}
			else
			{
				formatex(uvarsex, 99, uvars);
			}				
			menu_additem( menu, mitemn, uvarsex, 0, menu_makecallback("lt_adminmainmenu_cb") );
			totalgroup++;
			if(CurrentArray[df_others] && j == 0)
			{
				for(new j = 0; j < ArraySize(CurrentArray[df_others]); j++)
				{
					new OVALUE[defs_othervars];
					ArrayGetArray(CurrentArray[df_others], j, OVALUE);
					new bool:isok = false;
					new grptag[50];
					if(str_ended(OVALUE[dov_name], ":GRP_ACCESS") && !equali(OVALUE[dov_name], ":GRP_ACCESS"))
					{
						isok = true;
					}
					if(!isok && str_ended(OVALUE[dov_name], ":GRP_TAG") && !equali(OVALUE[dov_name], ":GRP_TAG"))
					{
						isok = true;
					}
					if(!isok) continue;
					
					new SplitStrEx[2][50];
					ExplodeStringEx(SplitStrEx, 2, 49, OVALUE[dov_name], ":");
					trim(SplitStrEx[0]);
					if(strlen(SplitStrEx[0]) == 0) continue;
					new bool:eklenmis = false;
					new SplitStrK[50];
					formatex(SplitStrK, 49, "%s-%s", uvars ,SplitStrEx[0]);
					for(new k = 0; k < ArraySize(TempList); k++)
					{
						new stra[50];
						ArrayGetString(TempList, k, stra, 49);
						if(equali(stra, SplitStrK))
						{
							eklenmis = true
						}
					}
					if(eklenmis) continue;

					ArrayPushString(TempList, SplitStrK);
					new nsname[50];
					formatex(nsname, 49, "%s:GRP_TAG", SplitStrEx[0]);
					if(!get_groupitem_value(CurrentArray, nsname, grptag, 49))
					{
						formatex(grptag, 49, CurrentArray[df_grp_tag]);
					}
					new uvarsalt[50];
					formatex(uvarsalt, 49, "%s-%s", uvars, SplitStrEx[0]);
					formatex(mitemn, 99, "%s-%s \w(\d %s\w)", uvars, SplitStrEx[0], grptag);
					menu_additem( menu, mitemn, uvarsalt, 0, menu_makecallback("lt_adminmainmenu_cb") );
					totalgroup++;
				}
			}
		}
	}
	ArrayDestroy(TempList);
	if(totalgroup <= 0)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_LIST_USERGG");
		menu_destroy(menu);
		set_task(0.1, "list_username", id)
		return;
	}		
	formatex(nUserActiveItems[id][uai_activeaction],  29, "usergroup_select");
	menu_display(id, menu, 0);
}
public list_username(id)
{
	li_listaction(id, 1);
}
public list_usergroup(id)
{
	li_listaction(id, 2);
}
public list_adminlist(id)
{
	li_listaction(id, 3);
}
public lt_showabout(id)
{
	console_print(id, "Lt - AdminGroup And Say Addon by Lt.Ibrahim(Ibm)");
	console_print(id, "Version: 1.2.3");
	console_print(id, "Feedback: lt.ibrahim@hotmail.com");
	console_print(id, "Web: www.ltibmcode.com");
	return PLUGIN_HANDLED;
}
stock lt_getgroupinfo(const grp[])
{
	new grpnme_a[30];
	new grpvalue_a[30];
	new grpall[60];
	formatex(grpall, 59, grp);
	new SplitStrEx[2][30];
	ExplodeStringEx(SplitStrEx, 2, 29, grp, "-");
	formatex(grpnme_a, 29, SplitStrEx[0]);
	formatex(grpvalue_a, 29, SplitStrEx[1]);
	new firstfound;
	new CFurrentArray[defs_default];
	CFurrentArray[df_IsEmpty] = true;
	for(new i = 0; i < ArraySize(msg_Groups); i++)
	{
		new CurrentArray[defs_default];
		ArrayGetArray(msg_Groups, i, CurrentArray);
		for (new j = 0; j < CurrentArray[df_headerscount]; j++)
		{
			new uvars[1024];
			ArrayGetString(CurrentArray[df_headers], j, uvars, 1023);
			if(equali(uvars, grpall))
			{
				return CurrentArray;
			}
			if(equali(uvars, grpnme_a) && firstfound <= 0)
			{
				firstfound = 1;
				CFurrentArray = CurrentArray;
			}
		}
	}
	return CFurrentArray;
}
public lt_showprompt(id, const act[])
{
	new nUivals[usersini_vals];
	nUivals = uai_udata[id];
	if(!equali(act, "LT_ADM_SAVE"))
	{
		if(nUivals[uiv_isblank] || nUivals[uiv_issummary] || nUivals[uiv_removed]) return;
	}
	new strk[512];
	new LangStr[255];
	new mlstr = charsmax(LangStr);
	new mlstrk = charsmax(strk);
	new strkwrtten = 0;
	strkwrtten += formatex(strk[strkwrtten], mlstrk - strkwrtten, "\r%L", id, "LT_ADM_ASK_QST", id, act);
	new menu = menu_create(strk, "LtAdminPromptHandler")
	new actex[50];
	formatex(actex, 49, "prompt_ok_%s", act);
	formatex(LangStr, mlstr, "%L", id, "LT_ADM_ASK_Y");
	menu_additem( menu, LangStr, actex, 0, menu_makecallback("lt_adminmainmenu_cb") );
	formatex(LangStr, mlstr, "%L", id, "LT_ADM_ASK_N");
	menu_additem( menu, LangStr, "no", 0, menu_makecallback("lt_adminmainmenu_cb") );
	menu_display(id, menu, 0);
}
public LtAdminPromptHandler(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy( menu );
		if(lastmenuissavetofile[id])
		{
			set_task(0.1, "lt_showadminmenu", id)
		}
		else
		{
			set_task(0.1, "lt_showadmininfomenu", id)
		}

		lastmenuissavetofile[id] = false;
		return;
	}
	if(nUserActiveItems[id][uai_lastloaded] != totalloaded)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_ANY");
		menu_destroy( menu );
		return;
	}
	new itemarg[30], MenuItemName[32];
	new access, callback;
	menu_item_getinfo( menu, item, access, itemarg, charsmax(itemarg), MenuItemName, 31, callback)
	if(equal(itemarg, "prompt_ok_LT_ADM_EM_I1")) //Save
	{
		new nUsername[100];
		new bool:is_new = nUserActiveItems[id][uai_isnew];
		new CFurrentArray[defs_default];
		CFurrentArray = lt_getgroupinfo(uai_udata[id][uiv_usergroup]);
		if(!CFurrentArray[df_IsEmpty] && !userformats_c[id][de_ini_notorderobey])
		{
			new destorder = CFurrentArray[df_grp_order];
			new uorder = userformats_c[id][de_grp_order];
			if(destorder > uorder)
			{
				client_print(id, print_chat, "%s%L", prefix, id, "LT_ADD_ERR_ACC", uai_udata[id][uiv_usergroup]);
				set_task(0.1, "lt_showadmininfomenu", id)
				menu_destroy( menu );
				return;
			}
		}
		new upref[30];
		get_pcvar_string(pcvar_clanprefix, upref, 29);
		if(is_new && !str_started(uai_udata[id][uiv_username], "STEAM_") && !userformats_c[id][de_ini_addnopref] && !str_started(uai_udata[id][uiv_username], upref))
		{
			if(strlen(uai_udata[id][uiv_username]) <= 0)
			{
				client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERRLESS");
				set_task(0.1, "lt_showadmininfomenu", id)
				menu_destroy( menu );
				return;
			}

			formatex(nUsername, 99, "%s%s", upref, uai_udata[id][uiv_username]);
		}
		else
		{
			formatex(nUsername, 99, uai_udata[id][uiv_username]) 
		}
		if(!username_ok(id, nUsername, true, is_new) || !access_ok(id, uai_udata[id][uiv_access], true))
		{
			set_task(0.1, "lt_showadmininfomenu", id);
			menu_destroy( menu );
			return;
		}
		formatex(uai_udata[id][uiv_username], 99, nUsername);
		new uname[60];
		get_user_name(id, uname, 59);
		formatex(uai_udata[id][uiv_written], 99, uname);
		if(is_new)
		{
			nUserActiveItems[id][uai_udataindex] = ArrayPushArray(CurrentUsersIni, uai_udata[id]);
			nUserActiveItems[id][uai_isnew] = false;
			nUserActiveItems[id][uai_lastpage] = (nTotalUserCount) / 7;
			nTotalUserCount++;
		}
		else
		{
			ArraySetArray(CurrentUsersIni, nUserActiveItems[id][uai_udataindex], uai_udata[id]);
		}
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_SAVE_OK", uai_udata[id][uiv_username], uai_udata[id][uiv_password]);
		if(get_pcvar_num(pcvar_autosaveaftermodify))
		{
			save_userinidatas(CurrentUsersIni, "", nTotalUserCount, nTotalBlankCount, nTotalSummaryCount);
			server_cmd("amx_reloadadmins 1");
			set_task(0.2, "recreate_users");
		}
		set_task(0.1, "lt_showadmininfomenu", id);
	}
	else if(equal(itemarg, "prompt_ok_LT_ADM_EM_I2")) //Delete
	{
		uai_udata[id][uiv_removed] = true;
		nTotalUserCount--;
		nUserActiveItems[id][uai_lastpage] = (nTotalUserCount) / 7;
		ArraySetArray(CurrentUsersIni, nUserActiveItems[id][uai_udataindex], uai_udata[id]);
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_DEL_OK", uai_udata[id][uiv_username]);
		set_task(0.1, "lt_showlastmenu", id)
	}
	else if(equal(itemarg, "prompt_ok_LT_ADM_SAVE")) //Save All users
	{
		new saved = 0;
		saved = save_userinidatas(CurrentUsersIni, "", nTotalUserCount, nTotalBlankCount, nTotalSummaryCount);
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_SAVE_ALL", saved);
		server_cmd("amx_reloadadmins 1");
		set_task(0.2, "recreate_users");
	}
	else
	{
		if(lastmenuissavetofile[id])
		{
			set_task(0.1, "lt_showadminmenu", id)
		}
		else
		{
			set_task(0.1, "lt_showadmininfomenu", id);
		}
		lastmenuissavetofile[id] = false;
	}
	menu_destroy( menu );
}
stock bool:access_ok(id, const acc[], bool:showmessage = false)
{
	new stlenarg = strlen(acc);
	if(stlenarg < 1)
	{
		if(showmessage)
		{
			client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERRLESS");
		}
		return false;

	}
	new n_acc[50];
	formatex(n_acc, 49, acc);
	replace_all(n_acc, 49, "z", "");
	replace_all(n_acc, 49, "v", "");
	replace_all(n_acc, 49, " ", "");
	new uflags = get_user_flags(id);
	new OutFlags[50];
	get_flags(uflags, OutFlags, 49);
	new stlentflags = strlen(OutFlags);
	new n_stlenarg = strlen(n_acc);
	replace_all(OutFlags, 49, "z", "");
	replace_all(OutFlags, 49, "v", "");
	replace_all(OutFlags, 49, " ", "");
	new bool:noaccess = false;
	if(stlentflags <= 0)
	{
		noaccess = true;
	}
	if(!noaccess && stlentflags < n_stlenarg)
	{
		noaccess = true;
	}
	if(!noaccess)
	{
		for(new i = 0; i < stlentflags; i++)
		{
			new txt_c[2];
			copy(txt_c, 1, OutFlags[i]);
			replace_all(n_acc, 49, txt_c, "");
		}
		if(strlen(n_acc) > 0)
		{
			noaccess = true;
		}
	}
	if(noaccess)
	{
		if(showmessage) client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_MR_ACC");
		return false;
	}
	return true;
}
stock bool:username_ok(id, const unm[], bool:showmessage = false, bool:isnew = false)
{
	new stlenarg = strlen(unm);
	if(stlenarg < 1)
	{
		if(showmessage)
		{
			client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERRLESS");
		}
		return false;

	}
	else
	{
		if(isnew)
		{
			new inick = nick_indexof(unm);
			if(inick >= 0)
			{
				if(showmessage)
				{
					client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERRNICK");
				}
				return false;
			}
		}

	}
	return true;
}
public lt_KullaniciAdiAndOth(id, level, cid)
{
	if(nUserActiveItems[id][uai_lastloaded] != totalloaded)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_ANY");
		return PLUGIN_HANDLED;
	}
	if(!nUserActiveItems[id][uai_inmenu])
	{
		return PLUGIN_HANDLED;
	}
	
	nUserActiveItems[id][uai_inmenu] = false;
	new xp_arg[110];
	read_args(xp_arg, 109);
	remove_quotes(xp_arg);
	new itemarg[30];
	formatex(itemarg, 29, nUserActiveItems[id][uai_activeaction]);
	replace_all(xp_arg, 109, "^"", "");
	TrimBoth(xp_arg, xp_arg, ' ');
	new stlenarg = strlen(xp_arg);
	new upref[30];
	get_pcvar_string(pcvar_clanprefix, upref, 29);
	new kicktypeauto = get_pcvar_num(pcvar_kicktypeauto);
	if(equal(itemarg, "modify_username"))
	{
		if(stlenarg < 1)
		{
			client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERRLESS");
			set_task(0.1, "list_username", id);
			return PLUGIN_HANDLED;
		}
		else
		{
			new nname[100];
			if(!str_started(xp_arg, upref) && !userformats_c[id][de_ini_addnopref] && !str_started(xp_arg, "STEAM_"))
			{
				formatex(nname, 00, "%s%s", upref, xp_arg);
			}
			else
			{
				formatex(nname, 00, "%s", xp_arg);
			}
			new inick = nick_indexof(nname);
			if(inick >= 0)
			{
				client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERRNICK");
				set_task(0.1, "list_username", id);
				return PLUGIN_HANDLED;
			}
			else
			{
				if(kicktypeauto)
				{
					if(str_started(xp_arg, "STEAM_"))
					{
						formatex(uai_udata[id][uiv_kicktype], 99, "ce");
					}
					else
					{
						formatex(uai_udata[id][uiv_kicktype], 99, "a");
					}
				}
				formatex(uai_udata[id][uiv_username], 99, xp_arg);
			}
		}
	}
	else if(equal(itemarg, "modify_password"))
	{
		formatex(uai_udata[id][uiv_password], 99, xp_arg);
	}
	else if(equal(itemarg, "modify_kicktype"))
	{
		formatex(uai_udata[id][uiv_kicktype], 99, xp_arg);
	}
	else if(equal(itemarg, "modify_access"))
	{
		if(access_ok(id, xp_arg, true))
		{
			formatex(uai_udata[id][uiv_access], 99, xp_arg);
		}
	}
	else if(equal(itemarg, "modify_group"))
	{
		new CFurrentArray[defs_default];
		CFurrentArray = lt_getgroupinfo(xp_arg);
		if(!CFurrentArray[df_IsEmpty] && !userformats_c[id][de_ini_notorderobey])
		{
			new destorder = CFurrentArray[df_grp_order];
			new uorder = userformats_c[id][de_grp_order];
			if(destorder > uorder)
			{
				client_print(id, print_chat, "%s%L", prefix, id, "LT_ADD_ERR_ACC", xp_arg);
				set_task(0.1, "list_usergroup", id);
				return PLUGIN_HANDLED;
			}
		}
		formatex(uai_udata[id][uiv_usergroup], 99, xp_arg);
	}
	else if(equal(itemarg, "sl_admin_find"))
	{
		lt_showadminlistmenu(id, 0, xp_arg);
		return PLUGIN_HANDLED;
	}
	else if(equal(itemarg, "modify_entertag"))
	{
		replace_all(xp_arg, 109, "{g_desc}", "");
		if(strlen(xp_arg) <= 0)
		{
			client_print(id, print_chat, "%s%L", prefix, id, "LT_GRPN_ERRORTAG");
			formatex(uai_udata[id][uiv_usergroup], 99, "");
			set_task(0.1, "list_usergroup", id);
			return PLUGIN_HANDLED;
		}
		else
		{
			replace_all(uai_udata[id][uiv_usergroup], 99, "{g_desc}", xp_arg);
		}
	}
	set_task(0.1, "lt_showadmininfomenu", id)
	return PLUGIN_HANDLED;
}
public say_adminayarla(id)
{
	if(!get_pcvar_num(pcvar_enableinieditor))
	{
		return PLUGIN_CONTINUE;
	}
	if(!access(id, ADMIN_ADMIN))
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADD_ERR_ACCEN");
		return PLUGIN_HANDLED;
	}
	if(!userformats_c[id][de_ini_show])
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADD_ERR_ACCEN");
		return PLUGIN_HANDLED;
	}
	nUserActiveItems[id][uai_lastloaded] = totalloaded
	lt_showadminmenu(id);
	return PLUGIN_HANDLED;
}
public lt_showadmininfomenu(id)
{
	if(nUserActiveItems[id][uai_lastloaded] != totalloaded)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_ANY");
		return;
	}
	new nUivals[usersini_vals];
	nUivals = uai_udata[id];
	if(nUivals[uiv_isblank] || nUivals[uiv_issummary] || nUivals[uiv_removed]) return;
	new strk[512];
	new LangStr[255];
	new mlstr = charsmax(LangStr);
	new mlstrk = charsmax(strk);
	new strkwrtten = 0;
	new bool:isnew =  nUserActiveItems[id][uai_isnew];
	strkwrtten += formatex(strk[strkwrtten], mlstrk - strkwrtten, "\r%L", id,"LT_ADM_EM_I");
	new uwritten[100];
	formatex(uwritten, 99, nUivals[uiv_written]);
	if(strlen(uwritten) <= 0)
	{
		formatex(uwritten, 99, "%L", id, "LT_NOPE");
	}
	new uwrittenn[100];
	formatex(uwrittenn, 99, "%L", id, "LT_A_WRT", uwritten);
	strkwrtten += formatex(strk[strkwrtten], mlstrk - strkwrtten, "\w(%s) ", uwrittenn);
	new menu = menu_create(strk, "LtAdminModifyMenuHandler")
	new upref[30];
	get_pcvar_string(pcvar_clanprefix, upref, 29);
	if(isnew && !userformats_c[id][de_ini_addnopref] && !str_started(nUivals[uiv_username], upref) && !str_started(nUivals[uiv_username], "STEAM_"))
	{
		formatex(LangStr, mlstr, "%L%s", id, "LT_UI_USER", upref, nUivals[uiv_username]);
		menu_additem( menu, LangStr, "modify_username", 0, menu_makecallback("lt_adminmainmenu_cb") );	
	}
	else
	{	
		formatex(LangStr, mlstr, "%L", id, "LT_UI_USER", nUivals[uiv_username]);
		menu_additem( menu, LangStr, "modify_username", 0, menu_makecallback("lt_adminmainmenu_cb") );	
	}
	new destorder = uai_udata[id][uiv_grp_order];
	new uorder = userformats_c[id][de_grp_order];
	if(destorder > uorder)
	{
		formatex(LangStr, mlstr, "%L", id, "LT_UI_PASS", "***");
	}
	else
	{
		formatex(LangStr, mlstr, "%L", id, "LT_UI_PASS", nUivals[uiv_password]);
	}
	menu_additem( menu, LangStr, "modify_password", 0, menu_makecallback("lt_adminmainmenu_cb") );				
	formatex(LangStr, mlstr, "%L", id, "LT_UI_ACC", nUivals[uiv_access]);
	menu_additem( menu, LangStr, "modify_access", 0, menu_makecallback("lt_adminmainmenu_cb") );		
	formatex(LangStr, mlstr, "%L", id, "LT_UI_GRP", nUivals[uiv_usergroup]);
	menu_additem( menu, LangStr, "modify_group", 0, menu_makecallback("lt_adminmainmenu_cb") );
	if(!get_pcvar_num(pcvar_kicktypehide))
	{
		formatex(LangStr, mlstr, "%L", id, "LT_UI_KCK", nUivals[uiv_kicktype]);
		menu_additem( menu, LangStr, "modify_kicktype", 0, menu_makecallback("lt_adminmainmenu_cb") );	
	}

	formatex(LangStr, mlstr, "%L", id, "LT_ADM_EM_I1");
	menu_additem( menu, LangStr, "modify_save", 0, menu_makecallback("lt_adminmainmenu_cb") );
	formatex(LangStr, mlstr, "%L", id, "LT_ADM_EM_I2");
	if(!isnew)
	{
		menu_additem( menu, LangStr, "modify_delete", 0, menu_makecallback("lt_adminmainmenu_cb") );
	}
	menu_display(id, menu, 0);
}
public LtAdminModifyMenuHandler(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy( menu );
		set_task(0.1, "lt_showlastmenu", id)
		return;
	}
	if(nUserActiveItems[id][uai_lastloaded] != totalloaded)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_ANY");
		menu_destroy( menu );
		return;
	}
	new itemarg[30], MenuItemName[32];
	new access, callback;
	menu_item_getinfo( menu, item, access, itemarg, charsmax(itemarg), MenuItemName, 31, callback)
	formatex(nUserActiveItems[id][uai_activeaction], 29, itemarg);
	nUserActiveItems[id][uai_inmenu] = true;
	if(equal(itemarg, "modify_username"))
	{
		nUserActiveItems[id][uai_lasttype] = 1;
		set_task(0.1, "list_username", id);
	}
	else if(equal(itemarg, "modify_password"))
	{
		client_cmd(id, "messagemode lt_cPass");
	}
	else if(equal(itemarg, "modify_kicktype"))
	{
		client_cmd(id, "messagemode lt_cKickType");
	}
	else if(equal(itemarg, "modify_access"))
	{
		client_cmd(id, "messagemode lt_cAccess");
	}
	else if(equal(itemarg, "modify_group"))
	{
		nUserActiveItems[id][uai_lasttype] = 2;
		set_task(0.1, "list_usergroup", id);
		//client_cmd(id, "messagemode lt_cGroup");
	}
	else if(equal(itemarg, "modify_delete"))
	{
		set_task(0.1, "spromptdel", id);
	}
	else if(equal(itemarg, "modify_save"))
	{
		set_task(0.1, "spromptsave", id);
	}
	else
	{
		nUserActiveItems[id][uai_inmenu] = false;
	}
	menu_destroy( menu );
}
public spromptsave(id)
{
	lt_showprompt(id, "LT_ADM_EM_I1");
}
public spromptdel(id)
{
	lt_showprompt(id, "LT_ADM_EM_I2");
}
public spromptallsave(id)
{
	lt_showprompt(id, "LT_ADM_SAVE");
}
public lt_showlastmenu(id)
{
	if(nUserActiveItems[id][uai_isnew])
	{
		lt_showadminmenu(id);
	}
	else
	{
		lt_showadminlistmenu(id, nUserActiveItems[id][uai_lastpage], nUserActiveItems[id][uai_lastargs]);
	}
}
public lt_showadminlistmenu(id, page, const uquery[])
{	
	formatex(nUserActiveItems[id][uai_lastargs], 49, uquery);
	new n_game_list = equali(uquery, "!##ingame##!");
	new n_game_name = (strlen(uquery) > 0);
	new qtest[50];
	if(n_game_list)
	{
		formatex(qtest, 49, "%L", id, "LT_ADM_MOD_I");
	}
	else if(n_game_name)
	{
		formatex(qtest, 49, "%L", id, "LT_ADM_MOD_F", uquery);
	}
	else
	{
		formatex(qtest, 49, "%L", id, "LT_ADM_MOD_A");
	}
	if(nUserActiveItems[id][uai_lastloaded] != totalloaded)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_ANY");
		return;
	}
	new strk[255];
	new LangStr[255];
	new menu = menu_create("", "LtAdminListMenuHandler")
	formatex(LangStr, charsmax(LangStr), "%L", id, "LT_ADM_NEW");
	new mlstr = charsmax(LangStr);
	new totaladded = 0;
	for(new i = 0; i < ArraySize(CurrentUsersIni); i++)
	{
		new nUivals[usersini_vals];
		ArrayGetArray(CurrentUsersIni, i, nUivals);
		if(nUivals[uiv_isblank] || nUivals[uiv_issummary] || nUivals[uiv_removed]) continue;
		if(n_game_list)
		{
			if(!nick_hasplayinggame(nUivals[uiv_username]))
			{
				continue;
			}
		}
		else if(n_game_name)
		{
			if(containi(nUivals[uiv_username], uquery) < 0)
			{
				continue;
			}
		}
		new iformat[5];
		formatex(iformat, 4, "%i", i);
		formatex(LangStr, mlstr, "%s - \d%s", nUivals[uiv_username], nUivals[uiv_usergroup]);
		menu_additem( menu, LangStr, iformat, 0, menu_makecallback("lt_adminmainmenu_cb") );
		totaladded++;
	}
	if(totaladded <= 0)
	{
		if(n_game_name && !n_game_list)
		{
			client_print(id, print_chat, "%s%L", prefix, id, "LT_LIST_SEL3E", uquery);
		}
		else
		{
			client_print(id, print_chat, "%s%L", prefix, id, "LT_LIST_SEL3E1");
		}
		menu_destroy(menu);
		set_task(0.1, "list_adminlist", id);
		return;
	}
	formatex(strk, 254, "\r%L Menu", id,"LT_ADM_MOD", totaladded, qtest);
	menu_setprop(menu, MPROP_TITLE, strk);
	menu_display( id, menu, page );
}
stock nick_hasplayinggame(const unick[])
{
	for(new i = 1; i < 33; i++)
	{
		if(!is_user_connected(i)) continue;
		if(is_user_bot(i)) continue;
		new uname[50];
		new steamn[50];
		get_user_name(i, uname, 49);
		get_user_authid(i, steamn, 49);
		if(!equali(unick, uname) && !equal(unick, steamn))
		{
			continue;
		}
		return i;
	}
	return 0;
}
public LtAdminListMenuHandler(id, menu, item)
{
	if(nUserActiveItems[id][uai_lastloaded] != totalloaded)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_ANY");
		menu_destroy( menu );
		return;
	}
	if(item == MENU_EXIT)
	{
		menu_destroy( menu );
		set_task(0.1, "list_adminlist", id)
		return;
	}
	new mpage = item / 7;
	new itemarg[25], MenuItemName[32];
	new access, callback;
	menu_item_getinfo( menu, item, access, itemarg, charsmax(itemarg), MenuItemName, 31, callback)
	new itemnum = str_to_num(itemarg);
	if(itemnum >= 0)
	{
		ArrayGetArray(CurrentUsersIni, itemnum, uai_udata[id]);
		nUserActiveItems[id][uai_udataindex] = itemnum;
		nUserActiveItems[id][uai_isnew] = false;
		nUserActiveItems[id][uai_lastpage] = mpage;
		nUserActiveItems[id][uai_lastloaded] = totalloaded;
		lt_showadmininfomenu(id);
	}
	menu_destroy( menu );
}
public lt_showadminmenu(id)
{
	nUserActiveItems[id][uai_lastloaded]  = totalloaded;
	if(!get_pcvar_num(pcvar_enableinieditor))
	{
		return;
	}
	new strk[255];
	new LangStr[255];
	formatex(strk, 254, "\r%L", id,"LT_ADM_MENU");
	new menu = menu_create(strk, "LtAdminMainMenuHandler")
	formatex(LangStr, charsmax(LangStr), "%L", id, "LT_ADM_NEW");
	menu_additem( menu, LangStr, "main_addnew", 0, menu_makecallback("lt_adminmainmenu_cb") ); //Add new admin
	formatex(LangStr, charsmax(LangStr), "%L", id, "LT_ADM_MOD", nTotalUserCount, "");
	menu_additem( menu, LangStr, "main_showmodify", 0, menu_makecallback("lt_adminmainmenu_cb") ); //Show/Modify Admin
	formatex(LangStr, charsmax(LangStr), "%L", id, "LT_ADM_SAVE");
	menu_additem( menu, LangStr, "main_savetofile", 0, menu_makecallback("lt_adminmainmenu_cb") ); //Save All Changes to users.ini
	menu_display( id, menu, 0 );
}
public LtAdminMainMenuHandler(id, menu, item)
{
	if(nUserActiveItems[id][uai_lastloaded] != totalloaded)
	{
		client_print(id, print_chat, "%s%L", prefix, id, "LT_ADM_ERR_ANY");
		return;
	}
	if(item == MENU_EXIT)
	{
		menu_destroy( menu );
		return;
	}
	new itemarg[25], MenuItemName[32];
	new access, callback;
	menu_item_getinfo( menu, item, access, itemarg, charsmax(itemarg), MenuItemName, 31, callback)
	if(equal(itemarg, "main_showmodify"))
	{
		nUserActiveItems[id][uai_lasttype] = 3;
		set_task(0.1, "list_adminlist", id);
	}
	if(equal(itemarg, "main_addnew"))
	{
		new uacitem[useractiveitem];
		nUserActiveItems[id] = uacitem;
		new nUivals[usersini_vals];
		get_pcvar_string(pcvar_defaccess, nUivals[uiv_access], charsmax(nUivals[uiv_access]));
		get_pcvar_string(pcvar_defgroup, nUivals[uiv_usergroup], charsmax(nUivals[uiv_usergroup]));
		get_pcvar_string(pcvar_defkicktype, nUivals[uiv_kicktype], charsmax(nUivals[uiv_kicktype]));
		uai_udata[id] = nUivals;
		nUserActiveItems[id][uai_isnew] = true;
		nUserActiveItems[id][uai_lastloaded] = totalloaded;
		lt_showadmininfomenu(id);
	}
	if(equal(itemarg, "main_savetofile"))
	{
		lastmenuissavetofile[id] = true;
		nUserActiveItems[id][uai_lastloaded] = totalloaded;
		set_task(0.1, "spromptallsave", id);
	}
	menu_destroy( menu );
}
public lt_adminmainmenu_cb(id, menu, item)
{
	new itemarg[30];
	new MenuItemName[32];
	new access, callback;
	menu_item_getinfo( menu, item, access, itemarg, 29, MenuItemName, 31, callback)
	new destorder = uai_udata[id][uiv_grp_order];
	new uorder = userformats_c[id][de_grp_order];
	if(equal(itemarg, "modify_save") || equal(itemarg, "modify_delete"))
	{
		if(!userformats_c[id][de_ini_rmv] && equal(itemarg, "modify_delete")) 
		{
			return ITEM_DISABLED;
		}
		if(!userformats_c[id][de_ini_change] && equal(itemarg, "modify_save")) 
		{
			return ITEM_DISABLED;
		}
		if(destorder > uorder && !userformats_c[id][de_ini_notorderobey])
		{
			return ITEM_DISABLED;
		}
	}
	if(equal(itemarg, "main_addnew"))
	{
		if(!userformats_c[id][de_ini_add])
		{
			return ITEM_DISABLED;
		}
	}
	if(isNumeric(itemarg))
	{
		new nnum = str_to_num(itemarg);
		if(nnum >= 0)
		{
			if(userformats_c[id][de_ini_show] && !userformats_c[id][de_ini_rmv] && !userformats_c[id][de_ini_change])
			{
				return ITEM_DISABLED;
			}
		}
	}
	if(equal(itemarg, "main_savetofile"))
	{
		if(!userformats_c[id][de_ini_rmv] && !userformats_c[id][de_ini_change])
		{
			return ITEM_DISABLED;
		}
	}
	return ITEM_ENABLED;
}
public lt_checkaccess()
{
	lt_check_usersinibackup();
	if(!get_pcvar_num(pcvar_accessoverride)) return;
	for(new i = 1; i < 33; i++)
	{
		if(!is_user_connected(i)) continue;
		if(is_user_bot(i)) continue;
		new cuflag = get_user_flags(i);
		new cflags = userformats_c[i][de_grp_acc_flags];
		if(cflags != 0 && cflags != cuflag)
		{
			remove_user_flags(i, cuflag);
			set_user_flags(i, cflags);
		}
	}
}
public lt_check_usersinibackup()
{
	new Float:GameTime = get_gametime();
	if(GameTime > NextSaveTime)
	{
		new Float:ESure = get_pcvar_float(pcvar_autobackusersini);
		new nnum = get_pcvar_num(pcvar_autobackminuser);
		if(ESure <= 0.1) return;
		NextSaveTime = get_gametime() + ESure;
		new Array:GCurrentUsers;
		new ntotaladmins = 0;
		new ntotalsummary = 0;
		new ntotalblank = 0;
		GCurrentUsers = get_usersinidatas(ntotaladmins, ntotalblank, ntotalsummary);
		if(ntotaladmins && ntotaladmins >= nnum)
		{
			save_userinidatas(GCurrentUsers, "users_lt_backup.ini", ntotaladmins, ntotalblank, ntotalsummary);
		}
		ArrayDestroy(GCurrentUsers);
		reload_usersini();
		server_cmd("amx_reloadadmins 1");
		set_task(0.2, "recreate_all");
	}
}
public say_adminler(id)
{
	adminlerigoster(id);
}
stock save_userinidatas(Array:UIData, const d_filename[] = "", ntotaluser, ntotalblank, ntotalsummary)
{
	new acount = 0;
	new scount = 0;
	new configdir[80];
	get_configsdir(configdir, 79);
	if(strlen(d_filename) <= 0)
	{
		formatex(configdir, 79, "%s/users.ini", configdir);
	}
	else
	{
		formatex(configdir, 79, "%s/%s", configdir, d_filename);
	}
	new fp = fopen(configdir, "w");
	if (!fp)
	{
		return acount;
	}
	new Arrsize = ArraySize(UIData);
	for(new i = 0; i < Arrsize; i++)
	{
		new nUivals[usersini_vals];
		ArrayGetArray(UIData, i, nUivals);
		if(nUivals[uiv_isblank])
		{
			if(acount < ntotaluser || scount < ntotalsummary)
			{
				fprintf(fp, "^n");
			}
			continue;
		}
		if(nUivals[uiv_issummary])
		{
			fprintf(fp, nUivals[uiv_othervars]);
			scount++;
			if(scount >= ntotalsummary)
			{
				if(acount < ntotaluser)
				{
					fprintf(fp, "^r");
				}
			}
			continue;
		}
		if(nUivals[uiv_removed])
		{
			continue;
		}
		new stlenother = strlen(nUivals[uiv_othervars]);
		new newsum[500];
		new writtenlen = strlen(nUivals[uiv_written]);
		new strrnewsum = 0;
		if(writtenlen > 0)
		{
			if(stlenother == 0)
			{
				formatex(newsum, 499, "// WrittenBy: %s", nUivals[uiv_written]);
			}
			else
			{
				new ret;
				new error[100];
				new Regex:regex_handle = regex_match(nUivals[uiv_othervars], "// WrittenBy:(.+)|// Yazan:(.+)|//. WrittenBy:(.+)|//. Yazan:(.+)|//WrittenBy:(.+)|//Yazan:(.+)", ret, error, charsmax(error))
				if(regex_handle > REGEX_NO_MATCH)
				{
					formatex(newsum, 499, nUivals[uiv_othervars]);
					new written[100];
					regex_substr(regex_handle, ret - 1, written, charsmax(written));
					trim(written);
					regex_free(regex_handle);
					replace_all(newsum, 499, written, nUivals[uiv_written]);
				}
				else
				{
					if(containi(newsum, "//") >= 0)
					{
						formatex(newsum, 499, "%s WrittenBy: %s",nUivals[uiv_othervars], nUivals[uiv_written]);
					}
					else
					{
						formatex(newsum, 499, "%s // WrittenBy: %s", nUivals[uiv_othervars], nUivals[uiv_written]);
					}
				}
			}
			strrnewsum = strlen(newsum);
		}
		if(strrnewsum <= 0)
		{
			formatex(newsum, 499, nUivals[uiv_othervars]);
		}
		fprintf(fp, "^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" %s^n", nUivals[uiv_username], nUivals[uiv_password], nUivals[uiv_access], nUivals[uiv_kicktype], nUivals[uiv_usergroup], newsum);
		acount++;
	}
	fclose(fp);
	return acount;
}
stock nick_indexof(const nick[])
{
	for(new i = 0; i < ArraySize(CurrentUsersIni); i++)
	{
		new nUivals[usersini_vals];
		ArrayGetArray(CurrentUsersIni, i, nUivals);
		if(nUivals[uiv_isblank] || nUivals[uiv_issummary] || nUivals[uiv_removed]) continue;
		if(equali(nUivals[uiv_username], nick))
		{
			return i;
		}
	}
	return -1;
}
stock Array:get_usersinidatas(&totaladims, &totalbosluk = 0, &totalsummary = 0)
{
	new Array:nUIArray = ArrayCreate(usersini_vals);
	new configdir[80];
	get_configsdir(configdir, 79);
	formatex(configdir, 79, "%s/users.ini", configdir);
	new SplitStr[6][1024];
	new text[1024]
	new fp = fopen(configdir, "r");
	new kTotalA = 0;
	new kTotalB = 0;
	new kTotalS = 0;
	if (!fp)
	{
		return nUIArray;
	}
	while (!feof(fp))
	{
		new nUivals[usersini_vals];
		fgets(fp, text, charsmax(text));
		if (text[0] == ';')
		{
			formatex(nUivals[uiv_othervars], charsmax(nUivals[uiv_othervars]), text);
			nUivals[uiv_issummary] = true;
			kTotalS++;
			ArrayPushArray(nUIArray, nUivals);
			continue;
		}
		TrimBoth(text, text, '^n');
		TrimBoth(text, text, '^r');
		new stlen = strlen(text);
		if(stlen <= 0) 
		{
			nUivals[uiv_isblank] = true;
			ArrayPushArray(nUIArray, nUivals);
			continue;
		}
		for(new j = 0; j < 6; j++)
		{
			formatex(SplitStr[j], 1023, "");
		}
		new spltlen = ExplodeStringEx(SplitStr, 6, 1023, text, " ", true, true);
		TrimBoth(SplitStr[0], SplitStr[0], ' ');
		if(spltlen <= 0 || strlen(SplitStr[0]) <= 0)
		{
			nUivals[uiv_isblank] = true;
			ArrayPushArray(nUIArray, nUivals);
			kTotalB++;
			continue;
		}
		if(spltlen == 2)
		{
			formatex(nUivals[uiv_othervars], charsmax(nUivals[uiv_othervars]), text);
			nUivals[uiv_issummary] = true;
			ArrayPushArray(nUIArray, nUivals);
			kTotalS++;
			continue;
		}
		for(new i = 0; i < 4; i++)
		{
			remove_quotes(SplitStr[i]);
		}
		formatex(nUivals[uiv_username], charsmax(nUivals[uiv_username]), SplitStr[0]);
		formatex(nUivals[uiv_password], charsmax(nUivals[uiv_password]), SplitStr[1]);
		formatex(nUivals[uiv_access], charsmax(nUivals[uiv_access]), SplitStr[2]);
		formatex(nUivals[uiv_kicktype], charsmax(nUivals[uiv_kicktype]), SplitStr[3]);
		if(SplitStr[4][0] == '/' && SplitStr[4][1] == '/')
		{
			if(strlen(SplitStr[5]) > 0)
			{
				formatex(nUivals[uiv_othervars], charsmax(nUivals[uiv_othervars]), "%s %s", SplitStr[4], SplitStr[5]);
			}
			else
			{
				formatex(nUivals[uiv_othervars], charsmax(nUivals[uiv_othervars]), SplitStr[4]);
			}

		}
		else
		{
			remove_quotes(SplitStr[4]);
			formatex(nUivals[uiv_usergroup], charsmax(nUivals[uiv_usergroup]), SplitStr[4]);
			formatex(nUivals[uiv_othervars], charsmax(nUivals[uiv_othervars]), SplitStr[5]);
		}
		new ret;
		new error[100];
		new Regex:regex_handle = regex_match(nUivals[uiv_othervars], "// WrittenBy:(.+)|// Yazan:(.+)|//. WrittenBy:(.+)|//. Yazan:(.+)|//WrittenBy:(.+)|//Yazan:(.+)", ret, error, charsmax(error))
		if(regex_handle > REGEX_NO_MATCH)
		{
			new written[100];
			regex_substr(regex_handle, ret - 1, written, charsmax(written));
			regex_free(regex_handle);
			trim(written);
			formatex(nUivals[uiv_written], charsmax(nUivals[uiv_written]), written);
		}
		lt_loaduserformat(0, 1, nUivals[uiv_username], nUivals[uiv_usergroup]);
		nUivals[uiv_grp_order] = userformats_c[0][de_grp_order];
		formatex(nUivals[uiv_grp_access], charsmax(nUivals[uiv_grp_access]), userformats_c[0][de_grp_acc]);
		ResetData(0);
		ArrayPushArray(nUIArray, nUivals);
		kTotalA++;
	}
	totaladims = kTotalA;
	totalbosluk = kTotalB;
	totalsummary = kTotalS;
	fclose(fp);
	return nUIArray;
}
stock get_arrayindexbname(Array:inArray, const gname[])
{
	for(new i = 0; i < ArraySize(inArray); i++)
	{
		new GCArray[admin_groups];
		ArrayGetArray(inArray, i, GCArray);
		if(equali(GCArray[ag_grp_name], gname)) return i;
	}
	return -1;
}
public adminlerigoster(idg)
{
	new Array:UyeGruplari = ArrayCreate(admin_groups);
	for(new i = 1; i < 33; i++)
	{
		if(!is_user_connected(i)) continue;
		if(is_user_bot(i))continue;
		new id = i;
		if(userformats_c[id][de_grp_order] == 0) continue;
		if(strlen(userformats_c[id][de_grp_name]) == 0) continue;		
		new aindex = get_arrayindexbname(UyeGruplari, userformats_c[id][de_grp_name]);
		new GCArray[admin_groups]; 
		if(aindex == -1)
		{			
			formatex(GCArray[ag_grp_name], 49, userformats_c[id][de_grp_name]);
			formatex(GCArray[ag_grp_desc], 99, userformats_c[id][de_grp_desc]);
			GCArray[ag_grp_order] =  userformats_c[id][de_grp_order];
			GCArray[ag_users][0] = id;
			GCArray[ag_totalusers] = 1;
		}
		else
		{
			ArrayGetArray(UyeGruplari, aindex, GCArray);
			new tusers = GCArray[ag_totalusers];
			GCArray[ag_users][tusers] = id;
			GCArray[ag_totalusers] = tusers + 1;
		}
		if(aindex == -1)
		{
			ArrayPushArray(UyeGruplari, GCArray);
		}
		else
		{
			ArraySetArray(UyeGruplari, aindex, GCArray);
		}
	}
	ArraySort(UyeGruplari, "ag_orderdesc");
	new AContent[1536];
	new aconlen = charsmax(AContent);
	new totalw = 0;
	totalw += formatex(AContent[totalw], aconlen - totalw, "<html><head><style> ");
	totalw += formatex(AContent[totalw], aconlen - totalw, "td, th { border: 1px solid #dddddd; text-align: left; padding: 8px;} ");
	totalw += formatex(AContent[totalw], aconlen - totalw, "tr:nth-child(even) {background-color: #dddddd;} </style></head><body><h1><b>Online/Aktif Adminler</b></h1><br />");
	for(new i = 0; i < ArraySize(UyeGruplari); i++)
	{
		new GCArray[admin_groups];
		ArrayGetArray(UyeGruplari, i, GCArray);
		new Aciklama[100];
		if(strlen(GCArray[ag_grp_desc]))
		{
			formatex(Aciklama, 99, ": %s", GCArray[ag_grp_desc]);
		}
		totalw += formatex(AContent[totalw], aconlen - totalw, "<table><tr><th><b>%s</b>%s</th></tr>", GCArray[ag_grp_name], Aciklama);
		for(new j = 0; j < GCArray[ag_totalusers]; j++)
		{
			new uname[50];
			new uid = GCArray[ag_users][j];
			get_user_name(uid, uname, 49);
			totalw += formatex(AContent[totalw], aconlen - totalw, "<tr><td>%s</td></tr>", uname);
		}
		totalw += formatex(AContent[totalw], aconlen - totalw, "</table><br />");
	}
	ArrayDestroy(UyeGruplari);
	show_motd( idg, AContent, "Aktif Adminler" );
}
public ag_orderdesc(Array:senderarray, itema, itemb)
{
	static value1[admin_groups], value2[admin_groups];
	ArrayGetArray(senderarray, itema, value1);
	ArrayGetArray(senderarray, itemb, value2);
	if(value1[ag_grp_order] < value2[ag_grp_order])
	{
		return 1;
	}
	return 0;
}
public say_normal(id)
{
	hooksay(id, 0);
}
public say_teamex(id)
{
	hooksay(id, 1);
}
public hooksay(id, isteam)
{
	if(!get_pcvar_num(pcvar_enabled))
	{
		return PLUGIN_CONTINUE;
	}
	new astatus = is_user_alive(id);
	new stextid = get_user_msgid("SayText");
	new xp_arg[200];
	read_args(xp_arg, 199);
	remove_quotes(xp_arg);
	if(strlen(xp_arg) == 0) return PLUGIN_CONTINUE;
	new OutString[192];
	new StringTeam[100];
	new teamid = 0;
	if(isteam)
	{
		new uteam = get_user_team(id);
		if(uteam == 1)
		{
			formatex(StringTeam, 99, "#Cstrike_Chat_T");
			teamid = 1;
		}
		else if(uteam == 2)
		{
			formatex(StringTeam, 99, "#Cstrike_Chat_CT");
			teamid = 2;
		}
		else if(uteam == 3)
		{
			formatex(StringTeam, 99, "#Cstrike_Chat_Spec");
			teamid = 3;
		}
		else
		{
			formatex(StringTeam, 99, "#Chat");
		}
	}
	else
	{
		formatex(StringTeam, 99, "#Chat");
	}
	if(!get_saytext(id, StringTeam, xp_arg, OutString, 191))
	{
		return PLUGIN_CONTINUE;
	}
	formatex(ua_lastmessage[id], 191, OutString);
	if(get_pcvar_num(pcvar_allchat) <= 0) return PLUGIN_CONTINUE;
	//formatex(LastSayText, 191, OutString);
	for(new i = 1; i < 33; i++)
	{
		if(i == id) continue;
		if(!is_user_connected(i)) continue;
		if(is_user_bot(i)) continue;
		if(teamid != 0 && get_user_team(i) != teamid) continue;
		if(astatus == is_user_alive(i)) continue;
		message_begin(MSG_ONE, stextid, _, i);
		write_byte(id);
		write_string(OutString);
		message_end();
	}
	return PLUGIN_CONTINUE;
}
public lt_reloadusers_m(id, level, cid)
{
	if(!cmd_access(id,level,cid,0))
	{
		return PLUGIN_HANDLED;
	}
	server_cmd("amx_reloadadmins 1");
	set_task(0.2, "recreate_all");
	console_print(id, "%s All user group data has been reloaded.(Tum kullanici verileri yeniden yuklendi)", "[LT]");
	return PLUGIN_HANDLED;
}
public lt_reloadall_n(id, level, cid)
{
	if(!cmd_access(id,level,cid,0))
	{
		return PLUGIN_HANDLED;
	}
	server_cmd("amx_reloadadmins 1");
	set_task(0.2, "recreate_allextra");

	console_print(id, "%s All files and customization been reloaded(Tum dosya ve kisileslestirmeler yeniden yuklendi.).", "[LT]");
	return PLUGIN_HANDLED;
}
public recreate_allextra()
{
	reload_usersini();
	destroy_allarray();
	ArrayGetArray(TempDefs, 0, msg_Admin);
	ArrayGetArray(TempDefs, 0, msg_NonAdmin);
	init_arrays();
	loadinifile();
	recreate_users();
	lt_loaduserloaded_all();

}
public lt_reloadusersini_m(id, level, cid)
{
	if(!cmd_access(id,level,cid,0))
	{
		return PLUGIN_HANDLED;
	}
	reload_usersini();
	console_print(id, "%s users.ini files has been reloaded(dosya yeninden yuklendi).", "[LT]");
	return PLUGIN_HANDLED;
}
stock reload_usersini()
{
	if(CurrentUsersIni)
	{
		ArrayDestroy(CurrentUsersIni);
	}
	CurrentUsersIni = get_usersinidatas(nTotalUserCount, nTotalBlankCount, nTotalSummaryCount);
	lt_loaduserloaded_all();
	totalloaded++;
}
public lt_reloadini_m(id, level, cid)
{
	if(!cmd_access(id,level,cid,0))
	{
		return PLUGIN_HANDLED;
	}
	server_cmd("amx_reloadadmins 1");
	set_task(0.2, "recreate_all");
	console_print(id, "%s lt_admingroup.ini files has been reloaded(dosya yeninden yuklendi).", "[LT]");
	return PLUGIN_HANDLED;
}
public init_arrays()
{	
	msg_Groups = ArrayCreate(defs_default);
	msg_Customs = ArrayCreate(defs_default);
	TempDefs = ArrayCreate(defs_default);
	new Test[defs_default];
	ArrayPushArray(TempDefs, Test);
	msg_Admin[df_others] = ArrayCreate(defs_othervars);
	msg_NonAdmin[df_others] = ArrayCreate(defs_othervars);
}
public client_putinserver(id)
{
	lastmenuissavetofile[id] = false;
	userformats_c[id][de_userloaded] = false;
	new uacitem[useractiveitem];
	new uivex[usersini_vals];
	uai_udata[id] = uivex;
	nUserActiveItems[id] = uacitem;
	lt_loaduserformat(id);
	lt_loaduserloaded(id)
}
stock lt_loaduserloaded_all()
{
	for(new i = 1; i < 33; i++)
	{
		if(!is_user_connected(i)) continue;
		if(is_user_bot(i)) continue;
		userformats_c[i][de_userloaded] = false;
		lt_loaduserloaded(i);
	}
}
stock lt_loaduserloaded(id)
{
	new uname[50];
	get_user_name(id, uname, 49);
	new inick = nick_indexof(uname);
	if(inick >= 0)
	{
		userformats_c[id][de_userloaded] = true;
		return;
	}
	get_user_authid(id, uname, 49);
	inick = nick_indexof(uname);
	if(inick >= 0)
	{
		userformats_c[id][de_userloaded] = true;
		return;
	}
}
stock ResetData(id)
{
	new pformat[defs_user];
	copy(userformats_c[id], defs_user, pformat);
}
stock lt_loaduserformat(id, isadmin = 0, const unameex[] = "", const ugrp[] = "")
{
	new pformat[defs_user];
	copy(userformats_c[id], defs_user, pformat);
	userformats_c[id] = pformat;
	new uisadmin = isadmin;
	if(id)
	{
		uisadmin = is_user_admin(id);
	}
	if(uisadmin)
	{
		formatex(userformats_c[id][de_usersecondary_alive], 1023, msg_Admin[df_msg_alive]);
		formatex(userformats_c[id][de_usersecondary_dead], 1023, msg_Admin[df_msg_dead]);
		formatex(userformats_c[id][de_grp_name], 49, msg_Admin[df_grp_name]);
		formatex(userformats_c[id][de_grp_desc], 99, msg_Admin[df_grp_desc]);
		userformats_c[id][de_grp_order] =  msg_Admin[df_grp_order];
		formatex(userformats_c[id][de_grp_acc], 49, msg_Admin[df_grp_access]);
		formatex(userformats_c[id][de_grp_tag], 49, msg_Admin[df_grp_tag]);
		userformats_c[id][de_grp_others] = msg_Admin[df_others];	
		lt_set_user_others(id);
	}
	else
	{		
		formatex(userformats_c[id][de_usersecondary_alive], 1023, msg_NonAdmin[df_msg_alive]);
		formatex(userformats_c[id][de_usersecondary_dead], 1023, msg_NonAdmin[df_msg_dead]);
		formatex(userformats_c[id][de_grp_name], 49, msg_NonAdmin[df_grp_name]);
		formatex(userformats_c[id][de_grp_desc], 99, msg_NonAdmin[df_grp_desc]);
		formatex(userformats_c[id][de_grp_tag], 49, msg_NonAdmin[df_grp_tag]);
		userformats_c[id][de_grp_order] =  msg_NonAdmin[df_grp_order];
		userformats_c[id][de_grp_others] = msg_NonAdmin[df_others];
		lt_set_user_others(id);
	}
	if(id) userformats_c[id][de_useroldflags] = get_user_flags(id);
	new uname[100];
	new steamid[32];
	if(id)
	{
		get_user_grouptext(id, userformats_c[id][du_usergroup_name], userformats_c[id][du_usergroup_value], userformats_c[id][du_usergroup_valueall], userformats_c[id][de_usr_acc]);
		get_user_name(id, uname, 99);
		get_user_authid(id, steamid, charsmax(steamid));
	}
	else
	{
		formatex(uname, 99, unameex);
		formatex(steamid, 31, unameex);
		formatex(userformats_c[id][du_usergroup_valueall], 59, ugrp);
		new SplitStrEx[2][30];
		ExplodeStringEx(SplitStrEx, 2, 29, ugrp, "-");
		formatex(userformats_c[id][du_usergroup_name], 29, SplitStrEx[0]);
		formatex(userformats_c[id][du_usergroup_value], 29, SplitStrEx[1]);
	}
	for(new i = 0; i < ArraySize(msg_Customs); i++)
	{
		new CurrentArray[defs_default];
		ArrayGetArray(msg_Customs, i, CurrentArray);
		for (new j = 0; j < CurrentArray[df_headerscount]; j++)
		{
			new uvars[1024];
			ArrayGetString(CurrentArray[df_headers], j, uvars, 1023);
			if(equali(uname, uvars) || equali(steamid, uvars))
			{
				formatex(userformats_c[id][de_userprimary_alive], 1023, CurrentArray[df_msg_alive]);
				formatex(userformats_c[id][de_userprimary_dead], 1023, CurrentArray[df_msg_dead]);
				formatex(userformats_c[id][de_grp_name], 49, CurrentArray[df_grp_name]);
				formatex(userformats_c[id][de_grp_desc], 99, CurrentArray[df_grp_desc]);
				formatex(userformats_c[id][de_grp_acc], 49, CurrentArray[df_grp_access]);
				formatex(userformats_c[id][de_grp_tag], 49, CurrentArray[df_grp_tag]);
				userformats_c[id][de_grp_others] = CurrentArray[df_others];	
				userformats_c[id][de_grp_order] =  CurrentArray[df_grp_order];
				userformats_c[id][de_useprimary] = true;
				userformats_c[id][de_grp_spec] = true;
				//replace_all(userformats_c[id][de_userprimary_alive], 1023, "{grp_tag}", userformats_c[id][de_grp_tag]);
				//replace_all(userformats_c[id][de_userprimary_dead], 1023, "{grp_tag}", userformats_c[id][de_grp_tag]);
				xp_chekc_annsetaccess(id);
				lt_set_user_others(id);
				return;
			}
		}
	}
	new firstfound = -1;
	new secondfound = -1;
	new GenericFoundAlive[1024];
	new GenericFoundDead[1024];
	for(new i = 0; i < ArraySize(msg_Groups); i++)
	{
		new CurrentArray[defs_default];
		ArrayGetArray(msg_Groups, i, CurrentArray);
		for (new j = 0; j < CurrentArray[df_headerscount]; j++)
		{
			new uvars[1024];
			ArrayGetString(CurrentArray[df_headers], j, uvars, 1023);
			if(equali(uvars, userformats_c[id][du_usergroup_valueall]))
			{
				formatex(userformats_c[id][de_userprimary_alive], 1023, CurrentArray[df_msg_alive]);
				formatex(userformats_c[id][de_userprimary_dead], 1023, CurrentArray[df_msg_dead]);
				formatex(userformats_c[id][de_grp_name], 49, CurrentArray[df_grp_name]);
				formatex(userformats_c[id][de_grp_desc], 99, CurrentArray[df_grp_desc]);
				formatex(userformats_c[id][de_grp_acc], 49, CurrentArray[df_grp_access]);
				formatex(userformats_c[id][de_grp_tag], 49, CurrentArray[df_grp_tag]);
				userformats_c[id][de_grp_order] =  CurrentArray[df_grp_order];
				userformats_c[id][de_grp_others] = CurrentArray[df_others];	
				userformats_c[id][de_useprimary] = true;
				secondfound = 1;
				//replace_all(userformats_c[id][de_userprimary_alive], 1023, "{grp_tag}", userformats_c[id][de_grp_tag]);
				//replace_all(userformats_c[id][de_userprimary_dead], 1023, "{grp_tag}", userformats_c[id][de_grp_tag]);
				xp_chekc_annsetaccess(id);
				lt_set_user_others(id);
				return;
			}
			if(equali(uvars, userformats_c[id][du_usergroup_name]) && firstfound <= 0)
			{
				formatex(GenericFoundAlive, 1023, CurrentArray[df_msg_alive]);
				formatex(GenericFoundDead, 1023, CurrentArray[df_msg_dead]);
				formatex(userformats_c[id][de_grp_name], 49, CurrentArray[df_grp_name]);
				formatex(userformats_c[id][de_grp_desc], 99, CurrentArray[df_grp_desc]);
				formatex(userformats_c[id][de_grp_acc], 49, CurrentArray[df_grp_access]);
				formatex(userformats_c[id][de_grp_tag], 49, CurrentArray[df_grp_tag]);
				userformats_c[id][de_grp_others] = CurrentArray[df_others];	
				new nsname[50];
				formatex(nsname, 49, "%s:GRP_ACCESS", userformats_c[id][du_usergroup_value]);
				get_groupitem_value(CurrentArray, nsname, userformats_c[id][de_grp_acc], 49);
				formatex(nsname, 49, "%s:MSG_ALIVE", userformats_c[id][du_usergroup_value]);
				get_groupitem_value(CurrentArray, nsname, GenericFoundAlive, 1023);
				formatex(nsname, 49, "%s:MSG_DEAD", userformats_c[id][du_usergroup_value]);
				get_groupitem_value(CurrentArray, nsname, GenericFoundDead, 1023);
				formatex(nsname, 49, "%s:GRP_TAG", userformats_c[id][du_usergroup_value]);
				get_groupitem_value(CurrentArray, nsname, userformats_c[id][de_grp_tag], 49);
				userformats_c[id][de_grp_order] =  CurrentArray[df_grp_order];
				firstfound = 1;
				lt_set_user_others(id);
			}
		}
	}
	if(firstfound > 0 && secondfound <= 0)
	{
		//replace_all(GenericFoundAlive, 1023, "{grp_tag}", userformats_c[id][de_grp_tag]);
		//replace_all(GenericFoundDead, 1023, "{grp_tag}", userformats_c[id][de_grp_tag]);
		formatex(userformats_c[id][de_userprimary_alive], 1023, GenericFoundAlive);
		formatex(userformats_c[id][de_userprimary_dead], 1023, GenericFoundDead);
		userformats_c[id][de_useprimary] = true;

	}
	else
	{
		//replace_all(userformats_c[id][de_usersecondary_alive], 1023, "{grp_tag}", userformats_c[id][de_grp_tag]);
		//replace_all(userformats_c[id][de_usersecondary_dead], 1023, "{grp_tag}", userformats_c[id][de_grp_tag]);
	}
	xp_chekc_annsetaccess(id);

}
stock lt_set_user_others(id)
{
	new Array:UOther = userformats_c[id][de_grp_others];
	new bool:AllAcc = (get_otheritem_value_num(UOther, "INI_ACC_ALL") >= 1);
	if(AllAcc)
	{
		userformats_c[id][de_ini_add] = true;
		userformats_c[id][de_ini_change] = true;
		userformats_c[id][de_ini_rmv] = true;
		userformats_c[id][de_ini_show] = true;
	}
	else
	{
		userformats_c[id][de_ini_add] = (get_otheritem_value_num(UOther, "INI_ADD_USER") >= 1);
		userformats_c[id][de_ini_change] = (get_otheritem_value_num(UOther, "INI_EDIT_USER") >= 1);
		userformats_c[id][de_ini_rmv] = (get_otheritem_value_num(UOther, "INI_RMV_USER") >= 1);
		userformats_c[id][de_ini_show] = (get_otheritem_value_num(UOther, "INI_SHOW_USER") >= 1);
		if(!userformats_c[id][de_ini_show])
		{
			userformats_c[id][de_ini_show] = (userformats_c[id][de_ini_add] || userformats_c[id][de_ini_change] || userformats_c[id][de_ini_rmv]);
		}
	}
	userformats_c[id][de_spectag] = (get_otheritem_value_num(UOther, "LT_SPECTAG") >= 1);
	if(userformats_c[id][de_spectag])
	{
		get_user_tagfromfile(id, userformats_c[id][de_cst_tag], 49);
	}
	userformats_c[id][de_ini_addnopref] = (get_otheritem_value_num(UOther, "INI_ADD_NOPREF") >= 1);
	userformats_c[id][de_ini_notorderobey] = (get_otheritem_value_num(UOther, "INI_NOT_ORDEROBEY") >= 1);	

}
stock xp_chekc_annsetaccess(id)
{	
	if(!id) return;
	if(get_pcvar_num(pcvar_accessoverride))
	{
		new slen = strlen(userformats_c[id][de_grp_acc]);
		if(slen > 0)
		{
			new scomp = 0;
			if(userformats_c[id][de_grp_spec])
			{
				scomp = 1;
			}
			else
			{
				new ovkey[50];
				get_pcvar_string(pcvar_accessoverridekey, ovkey, 49);
				new slenov = strlen(ovkey);

				if(slenov == 0) scomp = 1;
				if(slenov && equali(userformats_c[id][de_usr_acc], ovkey))
				{
					scomp = 1;
				}
			}
			//server_print("burada scomp: %s == %s %i",userformats_c[id][de_usr_acc], ovkey, scomp);
			if(scomp)
			{
				new newflags = read_flags(userformats_c[id][de_grp_acc]);
				userformats_c[id][de_grp_acc_flags] = newflags;
				remove_user_flags(id, get_user_flags(id));
				set_user_flags(id, newflags);
			}
		}
	}
}
stock Float:get_otheritem_value_float(Array:ItemIArray, const iname[])
{
	new outstr[50];
	get_otheritem_value(ItemIArray, iname, outstr, 49);
	return str_to_float(outstr);
}
stock get_otheritem_value_num(Array:ItemIArray, const iname[])
{
	new outstr[50];
	get_otheritem_value(ItemIArray, iname, outstr, 49);
	return str_to_num(outstr);
}
stock bool:get_otheritem_value(Array:ItemIArray, const iname[], outstr[], outlen)
{
	if(!ItemIArray) return false;
	for(new i = 0; i < ArraySize(ItemIArray); i++)
	{
		new OVALUE[defs_othervars];
		ArrayGetArray(ItemIArray, i, OVALUE);
		if(equali(OVALUE[dov_name], iname))
		{
			if(!strlen(OVALUE[dov_value])) continue;
			formatex(outstr, outlen, OVALUE[dov_value]);
			return true;
		}
	}
	return false;
}
stock bool:get_groupitem_value(CurrentArray[defs_default], const iname[], outstr[], outlen)
{
	for(new i = 0; i < ArraySize(CurrentArray[df_others]); i++)
	{
		new OVALUE[defs_othervars];
		ArrayGetArray(CurrentArray[df_others], i, OVALUE);
		if(equali(OVALUE[dov_name], iname))
		{
			if(!strlen(OVALUE[dov_value])) continue;
			formatex(outstr, outlen, OVALUE[dov_value]);
			return true;
		}
	}
	return false;
}
stock bool:get_user_grouptext(id, oname[], ovalue[], otopvalue[], accvalue[])
{
	new text[256];
	new SplitStr[10][100];
	new stlen;
	new spltlen;
	new configdir[80];
	get_configsdir(configdir, 79);
	new uname[99];
	get_user_name(id, uname, 99);
	new steamid[32];
	get_user_authid(id, steamid, charsmax(steamid));
	formatex(configdir, 79, "%s/users.ini", configdir);
	new fp = fopen(configdir, "r");
	if (!fp)
	{
		return false;
	}
	while (!feof(fp))
	{
		fgets(fp, text, charsmax(text));
		if (text[0] == ';')
		{
			continue;
		}
		TrimBoth(text, text, '^n');
		TrimBoth(text, text, '^r');
		TrimBoth(text, text, ' ');
		stlen = strlen(text);
		if(stlen <= 0) continue;
		for(new j = 0; j < 10; j++)
		{
			formatex(SplitStr[j], 99, "");
		}
		spltlen = ExplodeStringEx(SplitStr, 10, 99, text, " ");
		if(spltlen <= 0) break;
		if(!equali(uname, SplitStr[0]) && !equali(steamid, SplitStr[0]))
		{
			continue;
		}
		formatex(accvalue, 49, SplitStr[2]);
		if(strlen(SplitStr[4]) > 0)
		{
			new SplitStrEx[2][30];
			ExplodeStringEx(SplitStrEx, 2, 29, SplitStr[4], "-");
			formatex(oname, 29, SplitStrEx[0]);
			formatex(ovalue, 29, SplitStrEx[1]);
			formatex(otopvalue, 59, SplitStr[4]);
			fclose(fp);
			return true;
		}
		break;
	}
	fclose(fp);
	return false;
}
public plugin_cfg()
{
	init_arrays();
	loadinifile();
	CurrentUsersIni = get_usersinidatas(nTotalUserCount, nTotalBlankCount, nTotalSummaryCount);
	totalloaded++;
}
public loadinifile()
{
	new MsgDeadStr[] = "MSG_DEAD";
	new MsgAlvStr[] = "MSG_ALIVE";
	new Array:gdefines = ArrayCreate(defs_variable);
	new configdir[80];
	get_configsdir(configdir, 79);
	formatex(configdir, 79, "%s/lt_admingroup.ini", configdir);
	new fp = fopen(configdir, "r");
	if (!fp)
	{
		return;
	}
	new text[1024];
	new SplitStr[64][1024];
	new stlen;
	new ctype;
	new spltlen;
	new mapname[100];
	new bool:HeadStart = false;
	new addedrows = 0;
	new LastGroupItem[defs_default];
	new LastCustomItem[defs_default];
	new Array:StrTemp = ArrayCreate(defs_default);
	ArrayPushArray(StrTemp, LastGroupItem);
	get_mapname(mapname,99);
	while (!feof(fp))
	{
		fgets(fp, text, charsmax(text));
		if (text[0] == ';')
		{
			continue;
		}
		TrimBoth(text, text, '^n');
		TrimBoth(text, text, '^r');
		TrimBoth(text, text, ' ');
		stlen = strlen(text);
		if(stlen <= 0) continue;
		HeadStart = false;
		if(str_started(text, "[") && str_ended(text, "]"))
		{
			TrimLeft(text, text, '[');
			TrimRight(text, text, ']');
			HeadStart = true;
		}
		for(new j = 0; j < 64; j++)
		{
			formatex(SplitStr[j], 1023, "");
		}
		if(HeadStart)
		{
			spltlen = ExplodeStringEx(SplitStr, 63, 1020, text, ", ");
		}
		else
		{
			spltlen = ExplodeStringEx(SplitStr, 63, 1020, text, "=");
		}
		for(new j = 0; j < 64; j++)
		{
			trim(SplitStr[j]);
		}
		if(HeadStart)
		{
			if(ctype == 4 || ctype == 5)
			{
				if(addedrows > 0)
				{
					if(ctype == 4)
					{
						ArrayPushArray(msg_Groups, LastGroupItem);
					}
					else
					{
						ArrayPushArray(msg_Customs, LastCustomItem);
					}
				}
			}
			if(equali(SplitStr[0], "DEFINE"))
			{
				ctype = 1;
				continue;
			}
			if(equali(SplitStr[0], "NON_ADMIN_DEF"))
			{
				ctype = 2;
			}
			if(equali(SplitStr[0], "ADMIN_DEF"))
			{
				ctype = 3;
			}
			if(equali(SplitStr[0], "GROUP_DEF"))
			{
				ArrayGetArray(StrTemp, 0, LastGroupItem);
				LastGroupItem[df_IsGroup] = true;
				ctype = 4;
			}
			if(equali(SplitStr[0], "CUSTOM_DEF"))
			{
				ArrayGetArray(StrTemp, 0, LastCustomItem);
				LastCustomItem[df_IsCustom] = true;
				ctype = 5;
			}
			if(ctype == 4 || ctype == 5)
			{
				new addedheaders = 0;
				if(ctype == 4)
				{
					LastGroupItem[df_headers] = ArrayCreate(1024);
					LastGroupItem[df_others] = ArrayCreate(defs_othervars);
				}					
				if(ctype == 5)
				{
					LastCustomItem[df_headers] = ArrayCreate(1024);
					LastCustomItem[df_others] = ArrayCreate(defs_othervars);
				}
				for(new g = 1; g < spltlen; g++)
				{
					if(SplitStr[g][0] == '^0')
					{
						continue;
					}
					if(ctype == 4)
					{
						ArrayPushString(LastGroupItem[df_headers], SplitStr[g]);
					}
					else
					{
						ArrayPushString(LastCustomItem[df_headers], SplitStr[g]);
					}
					addedheaders++;
				}
				if(ctype == 4)
				{
					LastGroupItem[df_headerscount] = addedheaders;
				}
				else
				{
					LastCustomItem[df_headerscount] = addedheaders;
				}
			}
			addedrows = 0;
			continue;
		}
		else
		{
			if(ctype == 0) continue;
			addedrows++;
			for(new i = 0; i < ArraySize(gdefines); i++)
			{
				new definesget[defs_variable];
				ArrayGetArray(gdefines, i, definesget);
				for(new cjjj = 0; cjjj < 64; cjjj++)
				{
					if(strlen(SplitStr[cjjj]) == 0)
					{
						break;
					}
					replace_all(SplitStr[cjjj], 1023, definesget[dfv_name], definesget[dfv_value])
				}
			}
			if(ctype == 1)	//define values
			{
				if(spltlen < 1) continue;
				if(strlen(SplitStr[1]) == 0) continue;
				new definesget[defs_variable];
				formatex(definesget[dfv_name], 1023,  SplitStr[0]);
				formatex(definesget[dfv_value], 1023,  SplitStr[1]);
				ArrayPushArray(gdefines, definesget);
				ArraySort(gdefines, "str_lencompare");
				/*new arrindex = findinArray(gdefines, SplitStr[0]);
				//if(arrindex < 0)
				{
					
					ArrayPushString(gdefinevalues, SplitStr[1]);
				}
				else
				{
					//ArraySetString(gdefinevalues, arrindex, SplitStr[1]);
				}*/
				continue;
			}
			if(ctype == 2) //NON_ADMIN_DEF
			{
				if(equali(SplitStr[0], MsgDeadStr))
				{
					formatex(msg_NonAdmin[df_msg_dead], DEF_MAX_LEN, SplitStr[1]);
				}
				else if(equali(SplitStr[0], MsgAlvStr))
				{
					formatex(msg_NonAdmin[df_msg_alive], DEF_MAX_LEN, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_ORDER"))
				{
					msg_NonAdmin[df_grp_order] = str_to_num(SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_NAME"))
				{
					formatex(msg_NonAdmin[df_grp_name], 49, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_DESC"))
				{
					formatex(msg_NonAdmin[df_grp_desc], 99, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_TAG"))
				{
					formatex(msg_NonAdmin[df_grp_tag], 49, SplitStr[1]);
				}
				else
				{
					new LDEFITEM[defs_othervars];
					formatex(LDEFITEM[dov_name], charsmax(LDEFITEM[dov_name]), SplitStr[0]);
					formatex(LDEFITEM[dov_value], charsmax(LDEFITEM[dov_value]), SplitStr[1]);
					ArrayPushArray(msg_NonAdmin[df_others], LDEFITEM);
				}
			}
			if(ctype == 3) //ADMIN_DEF
			{
				if(equali(SplitStr[0], MsgDeadStr))
				{
					formatex(msg_Admin[df_msg_dead], DEF_MAX_LEN, SplitStr[1]);
				}
				else if(equali(SplitStr[0], MsgAlvStr))
				{
					formatex(msg_Admin[df_msg_alive], DEF_MAX_LEN, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_ORDER"))
				{
					msg_Admin[df_grp_order] = str_to_num(SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_NAME"))
				{
					formatex(msg_Admin[df_grp_name], 49, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_DESC"))
				{
					formatex(msg_Admin[df_grp_desc], 99, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_ACCESS"))
				{
					formatex(msg_Admin[df_grp_access], 49, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_TAG"))
				{
					formatex(msg_Admin[df_grp_tag], 49, SplitStr[1]);
				}
				else
				{
					new LDEFITEM[defs_othervars];
					formatex(LDEFITEM[dov_name], charsmax(LDEFITEM[dov_name]), SplitStr[0]);
					formatex(LDEFITEM[dov_value], charsmax(LDEFITEM[dov_value]), SplitStr[1]);
					ArrayPushArray(msg_Admin[df_others], LDEFITEM);
				}
			}
			if(ctype == 4)
			{
				if(equali(SplitStr[0], MsgDeadStr))
				{
					formatex(LastGroupItem[df_msg_dead], DEF_MAX_LEN, SplitStr[1]);
				}
				else if(equali(SplitStr[0], MsgAlvStr))
				{
					formatex(LastGroupItem[df_msg_alive], DEF_MAX_LEN, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_ORDER"))
				{
					LastGroupItem[df_grp_order] = str_to_num(SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_NAME"))
				{
					formatex(LastGroupItem[df_grp_name], 49, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_DESC"))
				{
					formatex(LastGroupItem[df_grp_desc], 99, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_ACCESS"))
				{
					formatex(LastGroupItem[df_grp_access], 49, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_TAG"))
				{
					formatex(LastGroupItem[df_grp_tag], 49, SplitStr[1]);
				}
				else
				{
					new LDEFITEM[defs_othervars];
					formatex(LDEFITEM[dov_name], charsmax(LDEFITEM[dov_name]), SplitStr[0]);
					formatex(LDEFITEM[dov_value], charsmax(LDEFITEM[dov_value]), SplitStr[1]);
					ArrayPushArray(LastGroupItem[df_others], LDEFITEM);
				}
			}
			if(ctype == 5)
			{
				if(equali(SplitStr[0], MsgDeadStr))
				{
					formatex(LastCustomItem[df_msg_dead], DEF_MAX_LEN, SplitStr[1]);
				}
				else if(equali(SplitStr[0], MsgAlvStr))
				{	
					formatex(LastCustomItem[df_msg_alive], DEF_MAX_LEN, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_ORDER"))
				{
					LastCustomItem[df_grp_order] = str_to_num(SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_NAME"))
				{
					formatex(LastCustomItem[df_grp_name], 49, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_DESC"))
				{
					formatex(LastCustomItem[df_grp_desc], 99, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_ACCESS"))
				{
					formatex(LastCustomItem[df_grp_access], 49, SplitStr[1]);
				}
				else if(equali(SplitStr[0], "GRP_TAG"))
				{
					formatex(LastCustomItem[df_grp_tag], 49, SplitStr[1]);
				}
				else
				{
					new LDEFITEM[defs_othervars];
					formatex(LDEFITEM[dov_name], charsmax(LDEFITEM[dov_name]), SplitStr[0]);
					formatex(LDEFITEM[dov_value], charsmax(LDEFITEM[dov_value]), SplitStr[1]);
					ArrayPushArray(LastCustomItem[df_others], LDEFITEM);
				}
			}
		}
	}
	if(ctype == 4 || ctype == 5)
	{
		if(addedrows > 0)
		{
			if(ctype == 4)
			{
				ArrayPushArray(msg_Groups, LastGroupItem);
			}
			else
			{
				ArrayPushArray(msg_Customs, LastCustomItem);
			}
		}
	}
	fclose(fp);
	ArrayDestroy(gdefines);
	ArrayDestroy(StrTemp);
}
public str_lencompare(Array:senderarray, itema, itemb)
{
	static value1[defs_variable], value2[defs_variable];
	ArrayGetArray(senderarray, itema, value1);
	ArrayGetArray(senderarray, itemb, value2);
	if(strlen(value1[dfv_name]) < strlen(value2[dfv_name]))
	{
		return 1;
	}
	return 0;
}
public destroy_arrayinarray(Array:CArray)
{
	for(new i = 0; i < ArraySize(CArray); i++)
	{
		new ArrayC[defs_default];
		ArrayGetArray(CArray, i, ArrayC);
		if(ArrayC[df_headers])
		{
			ArrayDestroy(ArrayC[df_headers]);
		}
		if(ArrayC[df_others])
		{
			ArrayDestroy(ArrayC[df_others]);
		}
	}
}
public destroy_allarray()
{
	destroy_arrayinarray(msg_Groups);
	destroy_arrayinarray(msg_Customs);
	ArrayDestroy(msg_Groups);
	ArrayDestroy(msg_Customs);
	ArrayDestroy(msg_Admin[df_others]);
	ArrayDestroy(msg_NonAdmin[df_others]);
}
public recreate_all()
{
	destroy_allarray();
	ArrayGetArray(TempDefs, 0, msg_Admin);
	ArrayGetArray(TempDefs, 0, msg_NonAdmin);
	init_arrays();
	loadinifile();
	recreate_users();

}
public recreate_users()
{
	for(new i = 1; i < 33; i++)
	{
		if(!is_user_connected(i)) continue;
		if(is_user_bot(i)) continue;
		lt_loaduserformat(i);
	}
}
public bool:get_saytext(senderid, sMsg[], sText[], OutString[], outlen)
{
	new newText[200];
	formatex(newText, 199, sText);
	if(containi(sMsg, "Chat") == -1)
	{
		return false;
	}
	#if defined USE_ANTIKUFUR
	new isadmin = is_user_admin(senderid);
	new blockpts = 0;
	new noblockpts = 0;
	#endif
	if(newText[0] == '/' || newText[0] == '!')
	{
		#if defined USE_ANTIKUFUR
		if(!isadmin)
		{
			blockpts = xp_blocktextpoints(newText);
		}
		else
		{
			noblockpts = 1;
		}
		#endif
		#if defined USE_ANTIKUFUR
		if(get_pcvar_num(pcvar_speccar) >= 1 && !blockpts)
		{
			return false;
		}
		#else
		if(get_pcvar_num(pcvar_speccar) >= 1)
		{
			return false;
		}			
		#endif
	}
	#if defined USE_ANTIKUFUR
	if(!noblockpts) blockpts = xp_blocktextpoints(newText);
	if(blockpts > 0)
	{
		formatex(newText, 199, "Ben küfür etmeye çalışan dangalağın tekiyim.");
	}
	#endif
	if(userformats_c[senderid][de_useroldflags] != get_user_flags(senderid))
	{
		lt_loaduserformat(senderid);
	}
	hook_usersaytextex(senderid, newText, OutString, outlen);
	new NewString[192];
	if(equali(sMsg, "#Cstrike_Chat_T", 15) || equali(sMsg, "#Cstrike_Chat_T_Loc", 19))
	{
		formatex(NewString, 191, "^1(T) %s", OutString);
	}
	else if(equali(sMsg, "#Cstrike_Chat_CT", 16) || equali(sMsg, "#Cstrike_Chat_CT_Loc", 20))
	{
		formatex(NewString, 191, "^1(CT) %s", OutString);
	}
	else if(equali(sMsg, "#Cstrike_Chat_Spec", 19))
	{
		formatex(NewString, 191, "^1(Spec) %s", OutString);
	}
	else
	{
		if(OutString[0] != '^1' && OutString[0] != '^3' && OutString[0] != '^4')
		{
			formatex(NewString, 191, "^1%s", OutString);
		}
		else
		{
			formatex(NewString, 191, OutString);
		}
	}
	formatex(OutString, outlen, NewString);
	return true;
}
public hook_saytext(iMsgId, iMsgType, id)
{
	if(!get_pcvar_num(pcvar_enabled))
	{
		return PLUGIN_CONTINUE;
	}
	if( get_msg_args()!=4 )
		return PLUGIN_CONTINUE;
	
	new sMsg[256], senderid;
	get_msg_arg_string(2, sMsg, 255);
	senderid = get_msg_arg_int(1);
	if(containi(sMsg, "Chat") == -1)
	{
		return PLUGIN_CONTINUE;
	}
	set_msg_arg_string(2, ua_lastmessage[senderid]);
	/*
	new sMsg[256], sText[256], senderid;
	get_msg_arg_string(2, sMsg, 255);
	get_msg_arg_string(4, sText, 255);
	new OutString[192];
	senderid = get_msg_arg_int(1);
	if(strlen(LastSayText) <= 0 || get_pcvar_num(pcvar_allchat) <= 0)
	{
		if(!get_saytext(senderid, sMsg, sText, OutString, 191))
		{
			return PLUGIN_CONTINUE;
		}
		set_msg_arg_string(2, OutString);
	}
	else
	{
		set_msg_arg_string(2, LastSayText);
	}
	//set_msg_arg_string(4, "")
	formatex(LastSayText, 191, "");*/
	return PLUGIN_CONTINUE;
}
public hook_usersaytextex(id, sayMsg[], outstring[], outlen)
{
	if(userformats_c[id][de_useprimary])
	{
		if(is_user_alive(id))
		{
			converttofmtstring(id, sayMsg, userformats_c[id][de_userprimary_alive], outstring, outlen);
		}
		else
		{
			converttofmtstring(id, sayMsg, userformats_c[id][de_userprimary_dead], outstring, outlen);
		}
	}
	else
	{
		if(is_user_alive(id))
		{
			converttofmtstring(id, sayMsg, userformats_c[id][de_usersecondary_alive], outstring, outlen);
		}
		else
		{
			converttofmtstring(id, sayMsg, userformats_c[id][de_usersecondary_dead], outstring, outlen);
		}
	}

}
public converttofmtstring(senderid, messagesring[], formatstring[], outstring[], outlen)
{
	new uname[100];
	get_user_name(senderid, uname, 99);
	formatex(outstring, outlen, formatstring);
	replace_all(outstring, outlen, "{name}", uname);
	new teamstr[100];
	formatex(teamstr, 99, "None");
	if(get_user_team(senderid) == 1)
	{
		formatex(teamstr, 99, "T");
	}
	if(get_user_team(senderid) == 2)
	{
		formatex(teamstr, 99, "CT");
	}
	if(get_user_team(senderid) == 3)
	{
		formatex(teamstr, 99, "SPEC");
	}
	replace_all(outstring, outlen, "{team}", teamstr)
	replace_all(outstring, outlen, "{g_name}", userformats_c[senderid][du_usergroup_name])

	replace_all(outstring, outlen, "{clr_green}", "^4");
	replace_all(outstring, outlen, "{clr_def}", "^1");
	replace_all(outstring, outlen, "{clr_team}", "^3");
	new utag[50];
	if(userformats_c[senderid][de_spectag])
	{
		formatex(utag, 49, userformats_c[senderid][de_cst_tag]);
		if(strlen(utag) <= 0 || equali(utag, "!"))
		{
			formatex(utag, 49, userformats_c[senderid][de_grp_tag]);
		}
	}
	else
	{
		formatex(utag, 49, userformats_c[senderid][de_grp_tag]);
	}
	replace_all(outstring, outlen, "{grp_tag}", utag);
	replace_all(outstring, outlen, "{g_desc}", userformats_c[senderid][du_usergroup_value])
	replace_all(outstring, outlen, "{msg}", messagesring);
}
public plugin_end()
{
	destroy_allarray();
	ArrayDestroy(TempDefs);
	if(CurrentUsersIni)
	{
		ArrayDestroy(CurrentUsersIni);
	}

}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
